/*
 * 数据模型
 * token数据模型
 * 薛原
 */
define(['RequestManager','md5','Shell'],function(RequestManager,md5,Shell){
	/*var timeId = 0;
	function touchStart(){
		if(timeId != 0){
			clearTimeout(timeId);
			timeId = 0;
		}
		Shell.sendEvent("LockSwitchActivity");
		$(window).unbind("touchend",touchEnd).bind("touchend",touchEnd);
	}
	function touchEnd(){
		$(window).unbind("touchend",touchEnd);
		timeId = setTimeout(function(){
			Shell.sendEvent("unLockSwitchActivity");
		},1000); 
	}
	$(window).unbind("touchstart",touchStart).bind("touchstart",touchStart);
	*/
	var TokenDataModel = {};
	TokenDataModel.getDataApi = "/ctl/api/token/login";
	TokenDataModel.getMatchingApi = "/ctl/cpcapi/bindpen/get_detect_rule_list"
	TokenDataModel.PREFIX_PASS = "YSNOTEPEN";
	TokenDataModel.TOKEN = null;
	TokenDataModel.ACCOUNT_CODE;
	TokenDataModel.setDomain = function(domain){
		try{
			api.setPrefs({
			    key: 'domain',
			    value: domain
		    });
		}catch(e){
			localStorage.setItem("domain",domain);
		}
	}
	TokenDataModel.getDomain = function(){
		var domain;
		try{
			domain = api.getPrefs({
				sync: true,
				key: 'domain'
			});
		}catch(e){
			domain = localStorage.getItem("domain");
			domain = "https://testsmartpen.ys100edu.com";
		}
		return domain;
	}
	TokenDataModel.getToken = function(element){
		if(TokenDataModel.TOKEN != null){
			element.trigger("MODEL_TOKEN_READY");
			return;
		}
		try{
			var token = api.getPrefs({
				sync: true,
				key: 'token'
			});
			if(token){
				TokenDataModel.TOKEN = token;
				element.trigger("MODEL_TOKEN_READY");
				return;
			}
		}catch(e){
		}
		var param = {};
		var data = {};
		param.data = data;
		TokenDataModel.ACCOUNT_CODE = TokenDataModel.ACCOUNT_CODE?TokenDataModel.ACCOUNT_CODE:"3845536128749059108";
		var accountCode = TokenDataModel.ACCOUNT_CODE;
		data.accountCode = accountCode;
		data.securityPass = createSecuriyPass(accountCode);
		param.url = TokenDataModel.getDomain()+TokenDataModel.getDataApi;
		param.type = "post";
		param.dataType = "json";
		param.success = function(ret){
			if(ret.retCode == "SUCCESS"){
				TokenDataModel.TOKEN = ret.data.token;
				if(element){
					try{
						api.setPrefs({
							key: 'token',
							value: TokenDataModel.TOKEN
						});
						Shell.sendEvent("setYsNoteToken",{"token":TokenDataModel.TOKEN});
					}catch(e){
					}
					TokenDataModel.getMatching();
				    element.trigger("MODEL_TOKEN_READY");
				}
			}
		}
		param.error = function(ret){
			Shell.sendEvent("backLogin",{"reason":"笔记服务异常"});
		}
		RequestManager.ajax(param);
	}
	//获取笔的匹配规则
	TokenDataModel.getMatching = function(){
		var param = {};
		var data = {};
		data.accountCode = TokenDataModel.ACCOUNT_CODE ? TokenDataModel.ACCOUNT_CODE : "3845536128749059108";
		data.token = TokenDataModel.TOKEN;
		param.data = data;
		param.url = TokenDataModel.getDomain()+TokenDataModel.getMatchingApi;
		param.type = "post";
		param.dataType = "json";
		param.success = function(ret){
			if(ret.retCode == "SUCCESS"){
				Shell.sendEvent("setBluetooth",{"bluetooth":ret.data});
			}
		}
		param.error = function(ret){
			Shell.sendEvent("backLogin",{"reason":"笔记服务异常"});
		}
		RequestManager.ajax(param);
	}
	//获取token加密鉴权密钥方法
	function createSecuriyPass(accountCode){
		var date = new Date();
		var year = date.getFullYear();
		var month = date.getMonth()+1<10?"0"+(date.getMonth()+1):date.getMonth()+1;
		var day = date.getDate()<10?"0"+date.getDate():date.getDate();
		var hour = date.getHours()<10?"0"+date.getHours():date.getHours();
		var dateFormat = year+""+month+""+day+""+hour;
		console.log(TokenDataModel.PREFIX_PASS+accountCode+dateFormat);
		return md5(TokenDataModel.PREFIX_PASS+accountCode+dateFormat);
	}
	return TokenDataModel;
});