define(['Shell'],function(Shell){
    var Download = {
        send:function(url,data,setParamCall){
            // console.log("__download_base_download_data:"+JSON.stringify(data))
            // var files = this._getFiles(data);
            // if(files.length === data.length){
            //     console.log("__download__hasFolder:none");
            //     return this._send(data);
            // }else{
                // console.log("__download__hasFolder:yes");
                var ids = this._getIds(data),rquestData;
                rquestData = setParamCall(ids.join(','));
                // console.log("__setParam:"+JSON.stringify(rquestData))
                this._request(url,rquestData,function(res){
                    try {
                        files = res.data.rows;
                    } catch (e) {
                        api.toast({msg: '获取下载文件失败',duration: 2000,location: 'middle'});
                        return;
                    }
                    files = Download._getFiles(files);
                    if(files == 0){
                        api.toast({msg:res.msg,duration: 2000,location: 'middle'});
                        return;
                    }else{
                        //api.toast({msg:"成功加入下载队列",duration: 2000,location: 'middle'});
                    }
                    Download._send(files)
                })
            // }
        },
        _request:function(url,param,success){
            $.ajax({
                url:url,
                data:param,
                success:success,
                error:function(res){
                    if(res.code == 1){
                        api.toast({msg: '网络异常，稍后重试',duration: 2000,location: 'middle'});
                    }else{
                        api.toast({msg: '服务器异常，稍后重试',duration: 2000,location: 'middle'});
                    }
                },
                exception:function(res){
                    api.toast({msg:res.msg,duration: 2000,location: 'middle'});
                },
            });
        },
        /**
         * 过滤掉文件夹
         */
        _getFiles:function(dataArr){
            var arr = [];
            for(var x in dataArr){
                dataArr[x].isdir != 1 && arr.push(dataArr[x]);
            }
            return arr;
        },
        _getIds:function (dataArr) {
            var arr = [];
            for(var x in dataArr){
                arr.push(dataArr[x].uuid);
            }
            return arr;
        },
        _send:function  (data){
            try {
                Shell.sendEvent('download',{'list':data});
                Shell.isAndroid() && Shell.sendEvent('hideTabBar',{ "hide": false });
            } catch (e) {
                console.warn(e)
            }
        }
    }
    return Download;
});
