/*
 * 网络请求管理器
 */
define(['Shell'],function(Shell){
	var RequestManager = {
	}
	RequestManager.ajax = function(params){
		try{
			var swapParams = {};
			swapParams.url = params.url;
			swapParams.method = params.type;
			if(params.dataType == "json"){
				swapParams.headers = {
					'Content-Type': 'application/json;charset=utf-8',
					'token': params.data.token,
					'accountCode': params.data.accountCode
				};
			}
			if(params.data){
				swapParams.data = {};
				swapParams.data.body = params.data;
			}
			var callback = function(ret, err){
				if(ret){
					params.success(ret);
				}else{
					params.error(err);
				}
			}
			api.ajax(swapParams,callback);
		}catch(e){
			$.ajax(params);
		}
	}
	return RequestManager;
});