/*
 * IconBox Icon图标组件
 * 作者：薛原
*/
define(['Icon','Img'],function(Icon){
	$.widget("ys.IconBox",$.ys.Img, {
		defalutImg:"../djcommon/img/file_icon_weishibie@3x.png", //默认图片
        _init: function () {
            this._super();
			var that = this;
			//读取global变量是否接入缩略图服务
			if(global.is_thumb_model == "yes"){ //开启了图片缩略图服务
				//console.log(this.options.data);
				if(this.options.data.file_type == "image" && ["png","jpg","jpeg","heic"].indexOf(this.options.data.ext) != -1){
					var src = "";
					if(global.version == "alone" || global.small_img_must_alone == true){
						src = global.urls.preview_config.thumb_config.get_thumb + "?uuid="+this.options.data.fileinfo_id+"&width="+global.thumb_width_height_config.width+"&height="+global.thumb_width_height_config.height+"&downUrl="+encodeURIComponent(global.urls.get_image_url+"?id="+this.options.data.fileinfo_id)+"&ext="+this.options.data.ext;
					}else{
						src = global.urls.preview_config.thumb_config.get_thumb + "?uuid="+this.options.data.fileinfo_id+"&width="+global.thumb_width_height_config.width+"&height="+global.thumb_width_height_config.height;
					}
					var img = new Image();
					img.onload = function(){
						that.element.find("img").attr("src",src);
					};
					img.onerror = function(){
						that.changeSrc(that.setTypeImg(that.options.data));
					};
					img.src = src;
				}else{
					this.changeSrc(this.setTypeImg(this.options.data));
				}
			}else{
				this.changeSrc(this.setTypeImg(this.options.data));
			}
        },
		setTypeImg:function(dic){
			return Icon.getIcon(dic.isdir == 1 ? 'folder':(dic.ext || ''));
		},
        //创建控件，控件生命周期内会运行多次
        _create: function () {
			this._super();
		},
        // 释放控件
        destroy: function () {
            $.Widget.prototype.destroy.call(this);
        }
    });
})
