/*
 * RightTextList
 * 薛原
 * 
*/
define(['Label','Panel',"Img"],function(require, exports){
    $.widget("ys.RightEnterList",$.ys.Panel, { 
        //默认参数
        _label:null,
        //初始化，控件生命周期内只运行一次
        _init: function () {
            this._super();  
			this.css("position","relative");
		    if(this.options.title){
				var textLabel =  $("<div></div>").Label({"text":this.options.title,"fontSize":"16px","color":"#000000","fontWeight":"500","lineHeight":this.options.height});
				textLabel.Label("setLeft","17px");
				textLabel.css("position","absolute");
				this.element.append(textLabel);
				var img = $("<div></div>").Img({"src":"../djcommon/img/note/enter.png","width":"6px","height":"9px"});
				img.css("position","absolute");
				img.Img("setRight","17px");
				img.Img("setTop","23px");
				this.element.bind("click",this,this.onClick);
				this.element.append(img);
			} 
			if(!this.options.hideTouchAnimate ){
				this.element.bind("touchstart",this,this.mousedownClick);
				this.element.bind("touchend",this,this.mouseupClick);
			}
		},
		onClick:function(e){
			e.data.element.trigger("LIST_CLICK");
		},
		mousedownClick:function(e){
			var _this = e.data;
			_this.enable && _this.element.css({"opacity":"0.5"})
		},
		mouseupClick:function(e){
			var _this = e.data;
			_this.enable && _this.element.css({"opacity":"1"})
		},
		/**
		* 改变文字颜色
		*/
        //创建控件，控件生命周期内会运行多次
        _create: function () {},
        // 释放控件
        destroy: function () {
            $.Widget.prototype.destroy.call(this);
        }
    });
})