/*
 * RightTextList
 * 薛原
 * 
*/
define(['Label','Panel','Img'],function(require, exports){
    $.widget("ys.RightSwitchList",$.ys.Panel, { 
        //默认参数
        _label:null,
        //初始化，控件生命周期内只运行一次
        _init: function () {
            this._super();  
			this.css("position","relative");
		    if(this.options.title){
				var textLabel =  $("<div></div>").Label({"text":this.options.title,"fontSize":"16px","color":"#000000","fontWeight":"500"});
				textLabel.Label("setLeft","17px");
				textLabel.Label("setTop","16px");
				textLabel.css("position","absolute");
				this.element.append(textLabel);
			} 
			if(this.options.switch == "on"){
				var switchBtn = $("<div class='switch-btn'></div>").Img({"src":"../djcommon/img/note/switch_on.png","width":"51px","height":"32px"});
			}else{
				var switchBtn = $("<div class='switch-btn'></div>").Img({"src":"../djcommon/img/note/switch_off.png","width":"51px","height":"32px"});
			}
			switchBtn.Img("setRight","17px");
			switchBtn.Img("setTop","12px");
			switchBtn.css("position","absolute");
			switchBtn.bind("click",this,this.switchBtnClick);
			this.element.append(switchBtn);
			
		},
		setSwitchOn:function(){
			this.options.switch = "on";
			this.element.find(".switch-btn").Img("setSrc","../djcommon/img/note/switch_on.png");
		},
		switchBtnClick:function(e){
			if(e.data.options.switch == "on"){
				e.data.options.switch = "off";
				e.data.element.find(".switch-btn").Img("setSrc","../djcommon/img/note/switch_off.png");
			}else{
				e.data.options.switch = "on";
				e.data.element.find(".switch-btn").Img("setSrc","../djcommon/img/note/switch_on.png");
			}
			e.data.element.trigger("SWITCH_CHANGED",{"status":e.data.options.switch});
		},
		_onMouseDown:function(e){ },    
        /**
		* 改变背景颜色
		*/
		changeBgColor:function(color){
			this.element.css("background",color);
		},
		/**
		* 改变文字颜色
		*/
        //创建控件，控件生命周期内会运行多次
        _create: function () {},
        // 释放控件
        destroy: function () {
            $.Widget.prototype.destroy.call(this);
        }
    });
})