/*
 * RightSwitchList
 * 薛原
 * 
*/
define(['Label','Panel'],function(require, exports){
    $.widget("ys.RightTextList",$.ys.Panel, { 
        //默认参数
        _label:null,
        //初始化，控件生命周期内只运行一次
        _init: function () {
            this._super();  
			this.css("position","relative");
		    if(this.options.title){
				var textLabel =  $("<div></div>").Label({"text":this.options.title,"fontSize":"16px","color":"#000000","fontWeight":"500","lineHeight":this.options.height});
				textLabel.Label("setLeft","17px");
				textLabel.css("position","absolute");
				this.element.append(textLabel);
				
				var valLabel =  $("<div></div>").Label({"text":this.options.val,"fontSize":"14px","color":"#666666","lineHeight":this.options.height});
				valLabel.Label("setRight","17px");
				valLabel.css("position","absolute");
				this.element.append(valLabel);
				this._valLabel = valLabel;
			} 
		},
		_onMouseDown:function(e){ },    
        /**
		* 改变背景颜色
		*/
		changeBgColor:function(color){
			this.element.css("background",color);
		},
		//改变文字内容
		changeText:function(text){
			this._valLabel.Label("setText",text);
		},	
		/**
		* 改变文字颜色
		*/
        //创建控件，控件生命周期内会运行多次
        _create: function () {},
        // 释放控件
        destroy: function () {
            $.Widget.prototype.destroy.call(this);
        }
    });
})