/** 控制文本显示行数 */
define(['jquery'], function($) {
    /** 仅显示一行，超出省略 */
    $.fn.oneline = function () {
        return this.css({"overflow":"hidden","textOverflow":"ellipsis","whiteSpace":"nowrap"});
    };
    /**
     * 显示多行，超出省略
     */
    $.fn.lines = function(lineInt){
        return this.css({"overflow":"hidden","WebkitLineClamp":lineInt||"2","WebkitBoxOrient":"vertical","display":"-webkit-box"})
    }
});