/*
*   2020年12月2日
*
*   新建笔记的js控制器
*
*   开发者：薛原
*/
define(["jquery","Shell","Fastclick","Config","NoteBookDataModel",'TokenDataModel',"NewHeader","Panel","Label","BaseBtn"], function ($,Shell,Fastclick,Config,NoteBookDataModel,TokenDataModel) {
	var bookType = "100";
	var bookName;
	var chooseBtn;
    var Controller = {
        init:function(){
			
            Controller.create();//调用生成页面方法
			Config.adapter.setBaseRem();
			Controller.addEventListener();
			//通知原生关闭加载动画
			setTimeout(function(){
				Shell.sendPageReady();
			},100);
        },
        //生成页面方法
        create:function(){
			var chooseBookLabel = $("<div class='linkStatusLabel'></div>").Label({"text":"请选择本子类型","fontSize":"24px","fontWeight":"600"});
			chooseBookLabel.Label("setPaddingLeft","15px");
			chooseBookLabel.Label("setMarginTop","40px");
			chooseBookLabel.Label("setMarginBottom","20px");
			var header = $("<div></div>").NewHeader({"title":"新建智能本","rightTitle":"帮助"});
			$("body").append(header);
			header.bind("RIGHT_CLICK",function(){
				//帮助页面
				Shell.sendEvent("openWin",{"url":"/notepenhelp/notePenHelp.html","open_type":true,"title":"帮助"});
			});
			header.bind("BACK_CLICK",function(){
				//关闭窗口
				Shell.sendEvent("closeWin");
			});
			var djBookArea = $("<div></div>").Panel({"width":"125px","height":"210px"});
			djBookArea.css("float","left");
			// djBookArea.Panel("setMarginRight","15px");
			djBookArea.Panel("setMarginLeft","15px");
			$("body").append(chooseBookLabel);
			var djBookImg = $("<div></div>").Img({"src":"../djcommon/img/note/dj_create_0.png","width":"125px","height":"170px"});
			djBookArea.Panel("addElement",djBookImg);
			var djBookTitle = $("<div></div>").Label({"text":"智能学习本","fontSize":"15px","fontWeight":"600"});
			djBookTitle.Label("setMarginTop","15px");
			djBookArea.Panel("addElement",djBookTitle);
			$("body").append(djBookArea);
			
		
			var deteBookArea = $("<div></div>").Panel({"width":"125px","height":"210px"});
			deteBookArea.Panel("setMarginLeft","15px");
			var dateBookImg = $("<div></div>").Img({"src":"../djcommon/img/note/date_create_0.png","width":"125px","height":"170px"});
			deteBookArea.css("float","left");
			deteBookArea.Panel("addElement",dateBookImg);
			var dateBookTitle = $("<div></div>").Label({"text":"纪念周历","fontSize":"15px","fontWeight":"600"});
			dateBookTitle.Label("setMarginTop","15px");
			var os;
			try{
				os = api.systemType;
			}catch(e){
				os = "android";
			}
			if(os == "android"){
			    deteBookArea.Panel("addElement",dateBookTitle);
				$("body").append(deteBookArea);
			}
			
			/*var da18BookArea = $("<div></div>").Panel({"width":"125px","height":"210px"});
			var da18BookImg = $("<div></div>").Img({"src":"../djcommon/img/note/book_2.png","width":"125px","height":"170px"});
			da18BookArea.css("float","left");
			da18BookArea.Panel("addElement",da18BookImg);
			var da18BookTitle = $("<div></div>").Label({"text":"区直机关党员手册","fontSize":"15px","fontWeight":"600"});
			da18BookTitle.Label("setMarginTop","15px");
			da18BookArea.Panel("addElement",da18BookTitle);
			$("body").append(deteBookArea);*/
			var tl2BookArea = $("<div></div>").Panel({"width":"125px","height":"210px"});
			// tl2BookArea.Panel("setMarginRight","15px");
			tl2BookArea.Panel("setMarginLeft","15px");
			var tl2BookImg = $("<div></div>").Img({"src":"../djcommon/img/note/tl_create_0.png","width":"125px","height":"170px"});
			tl2BookArea.css("float","left");
			tl2BookArea.Panel("addElement",tl2BookImg);
			var tl2BookTitle = $("<div></div>").Label({"text":"智能周历","fontSize":"15px","fontWeight":"600"});
			tl2BookTitle.Label("setMarginTop","15px");
			tl2BookArea.Panel("addElement",tl2BookTitle);
			$("body").append(tl2BookArea);

			var tenqianli = $("<div></div>").Panel({"width":"125px","height":"210px"});
			// tenqianli.Panel("setMarginRight","15px");
			tenqianli.Panel("setMarginLeft","15px");
			var tenqianliImg = $("<div></div>").Img({"src":"../djcommon/img/note/zd_create_0.png","width":"125px","height":"170px"});
			tenqianli.css("float","left");
			tenqianli.Panel("addElement",tenqianliImg);
			var tenqianliTitle = $("<div></div>").Label({"text":"党员学习本","fontSize":"15px","fontWeight":"600"});
			tenqianliTitle.Label("setMarginTop","15px");
			tenqianli.Panel("addElement",tenqianliTitle);
			$("body").append(tenqianli);
			
			djBookArea.bind("click",function(){
				chooseBtn.show();
				bookType = "100";
				bookName = "智能学习本";
				djBookImg.Img("setSrc","../djcommon/img/note/dj_create_1.png");
				//da18BookImg.Img("setSrc","../djcommon/img/note/da18_create_0.png");
				dateBookImg.Img("setSrc","../djcommon/img/note/date_create_0.png");
				tl2BookImg.Img("setSrc","../djcommon/img/note/tl_create_0.png");
				tenqianliImg.Img("setSrc","../djcommon/img/note/zd_create_0.png");
			});
			deteBookArea.bind("click",function(){
				chooseBtn.show();
				bookType = "300";
				bookName = "纪念周历";
				dateBookImg.Img("setSrc","../djcommon/img/note/date_create_1.png");
				djBookImg.Img("setSrc","../djcommon/img/note/dj_create_0.png");
				//da18BookImg.Img("setSrc","../djcommon/img/note/da18_create_0.png");
				tl2BookImg.Img("setSrc","../djcommon/img/note/tl_create_0.png");
				tenqianliImg.Img("setSrc","../djcommon/img/note/zd_create_0.png");
			});
			/*da18BookArea.bind("click",function(){
				chooseBtn.show();
				bookType = "200";
				bookName = "区直机关党员手册";
				djBookImg.Img("setSrc","../djcommon/img/note/dj_create_0.png");
				da18BookImg.Img("setSrc","../djcommon/img/note/da18_create_1.png");
			});*/
			tl2BookArea.bind("click",function(){
				chooseBtn.show();
				bookType = "310";
				bookName = "智能周历";
				tl2BookImg.Img("setSrc","../djcommon/img/note/tl_create_1.png");
				djBookImg.Img("setSrc","../djcommon/img/note/dj_create_0.png");
				dateBookImg.Img("setSrc","../djcommon/img/note/date_create_0.png");
				tenqianliImg.Img("setSrc","../djcommon/img/note/zd_create_0.png");
			});
			tenqianli.bind("click",function(){
				chooseBtn.show();
				bookType = "110";
				bookName = "党员学习本";
				tenqianliImg.Img("setSrc","../djcommon/img/note/zd_create_1.png");
				tl2BookImg.Img("setSrc","../djcommon/img/note/tl_create_0.png");
				djBookImg.Img("setSrc","../djcommon/img/note/dj_create_0.png");
				dateBookImg.Img("setSrc","../djcommon/img/note/date_create_0.png");
			});
			var clear = $("<div></div>").css("clear","both");
			$("body").append(clear);
			chooseBtn = $("<div></div>").BaseBtn({"text":"确认","width":"345px","height":"44px","textColor":"#ffffff","bgColor":"#C82128","borderRadius":"22px","fontSize":"15px","noNeedAutoUnlock":true});
			chooseBtn.css("position","absolute");
			chooseBtn.BaseBtn("setLeft","15px");
			chooseBtn.BaseBtn("setBottom","20px");
			$("body").append(chooseBtn);
			chooseBtn.bind("BTN_CLICK",function(){
				chooseBtn.BaseBtn("setDisable");
				NoteBookDataModel.createData(bookName,bookType);
			});

			chooseBtn.hide();
			//解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
		},
		addEventListener:function(){
			$(window).bind("CREATE_NOTE_BOOK_DATA_SUCCESS",function(e,data){
				try{ //手机环境通知其他页面党建本数据发生改变。
					Shell.sendEvent("NOTE_BOOK_DATA_CHANGE");
					api.toast({
						msg: '新建智能本成功',
						duration: 1000,
						location: 'middle'
					});
					setTimeout(function(){
					    Shell.sendEvent("closeWin");
					},1000);
				}catch(e){
				}
				
			});
			$(window).bind("CREATE_NOTE_BOOK_DATA_ERROR",function(e,data){
			    chooseBtn.BaseBtn("setEnable");
				api.toast({
				    msg: '请求失败,请检测网络',
					duration: 1000,
					location: 'middle'
				});
			});
			if(typeof(api) == "undefined"){
				TokenDataModel.ACCOUNT_CODE = "3845536128749059108";
			}else{
				TokenDataModel.ACCOUNT_CODE = localStorage.getItem("accountCode");
			}
		}
    }
    
    return Controller;
});
