/*
*   2020年12月2日
*
*   党建笔详情的js控制器
*
*   开发者：薛原
*/
define(["jquery","Shell","Fastclick","Config","iscroll","NotePenDataModel","TokenDataModel","NewHeader","Panel","Label","TitleList","RightTextList","RightSwitchList","RightEnterList","BaseBtn","ImgBtn"], function ($,Shell,Fastclick,Config,IScroll,NotePenDataModel,TokenDataModel) {
	var currPenData;
	var toastStatus = false;
	var needUnbind = false;
	var needBackFactory = false;
	var btnPanel;
	var maxSpace = "128M"; //笔容量写死
	var interWinLock = false;
	var myScroll;
    var Controller = {
        init:function(){
			$("body").css("background","#F7F8FA");
			if(typeof(api) == "undefined"){
				TokenDataModel.ACCOUNT_CODE = "3845536128749059108";
			}else{
				TokenDataModel.ACCOUNT_CODE = localStorage.getItem("accountCode");
			}
            Config.adapter.setBaseRem();
			var penData = NotePenDataModel.getLocationLinkedPenWithNoEvent();
			if(penData && typeof(penData.vid) != "undefined"){
				Controller.createHasLine(penData);//调用生成页面方法
				Shell.sendPageReady();
			}else{
				Controller.create();//调用生成页面方法
				Controller.addEventListener();//侦听壳事件			
				//通知原生关闭加载动画
				setTimeout(function(){
					Controller.getPenDetail();
					Shell.sendPageReady();
				},100);
				NotePenDataModel.getLocationLinkedPen();
			}
			//解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
        },
		createHasLine:function(penData){
			var header = $("<div></div>").NewHeader({"title":"设备详情"});
			Controller.contentHeader = header;
			header.NewHeader("setBottomLine");
			header.bind("BACK_CLICK",function(){
				//关闭窗口
				Shell.sendEvent("closeWin");
			});
			$("body").append(header);
			
			var scrollPanel = $("<div id='wrapper'></div>");
			scrollPanel.css("overflow","hidden");
			var ul = $("<ul></ul>");
			scrollPanel.append(ul);
			$("body").append(scrollPanel);
			
			var penStatusPanel = $("<li></li>").Panel({"width":"100%","height":"300px"});
			penStatusPanel.css("position","relative");
			penStatusPanel.Panel("setBgColor","#ffffff");
			var namePanel = $("<div class='namePanel'></div>").Panel({"width":"auto","height":"44px"});
			namePanel.css("text-align","center");
			penStatusPanel.append(namePanel);
			var mainText = $("<div class='mainText'></div>").Label({"text":"奕章有线笔","fontSize":"18px","fontWeight":"800","letterSpacing":"2px"});
			mainText.Label("setPaddingTop","150px");
			namePanel.append(mainText);
			
			var penIcon = $("<div></div>").Img({"src":"../djcommon/img/note/haslinepen.png","width":"173px","height":"20px"});
			penIcon.Img("setLeft","101px");
			penIcon.Img("setTop","90px");
			penIcon.css("position","absolute");
			penStatusPanel.append(penIcon);
			
			var secText = $("<div class='secText'></div>").Label({"text":"记载美好生活，从现在开始","fontSize":"14px","letterSpacing":"1px","color":"#cccccc"});
			secText.Label("setPaddingTop","10px");
			namePanel.append(secText);
			
			ul.append(penStatusPanel);
			
			var otherPanel = $("<li></li>").Panel({"width":"100%","height":"auto"});
			otherPanel.Panel("setMarginTop","10px");
			otherPanel.Panel("setBgColor","#ffffff");
			
			var otherTitleList =  $("<div></div>").TitleList({"title":"设备参数","fontSize":"14px","color":"#000000","fontWeight":"800","height":"40px"});
			otherPanel.Panel("addElement",otherTitleList);
			
			var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
			line.Panel("setBgColor","#EAEFF2");
			otherPanel.Panel("addElement",line);
			
			var PidList =  $("<div></div>").RightTextList({"title":"PID","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px","val":penData.pid});
			otherPanel.Panel("addElement",PidList);
			
			var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
			line.Panel("setBgColor","#EAEFF2");
			otherPanel.Panel("addElement",line);
			
			var VidList =  $("<div></div>").RightTextList({"title":"VID","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px","val":penData.vid});
			otherPanel.Panel("addElement",VidList);
			
			ul.append(otherPanel);
			
			
			try{
				api.addEventListener({"name":"loseLinkYsPen"},function(e){
					//可能收到多个事件-只触发一个飘窗-android不稳定
					if(!toastStatus){
						toastStatus = true;
						if(!needUnbind && !needBackFactory){ //既不是解除绑定,也不是恢复出厂
							api.toast({
								msg: '奕章有线笔连接已断开',
								duration: 1000,
								location: 'middle'
							});
							setTimeout(function(){
							    Shell.sendEvent("closeWin");
							},1500);
							//关闭窗口
							return;
							
						}
						NotePenDataModel.setLinked(0);
						setTimeout(function(){
						    toastStatus  = false;
						},1000);
					}
				});
			}catch(e){}
		},
		//获取笔详情，包括电量
		getPenDetail:function(){
			if(NotePenDataModel.getLinked()){
				//alert(currPenData);
				if(currPenData && typeof(currPenData.mac) != "undefined"){
					Shell.sendEvent("getYsPenDetailData",{"mac":currPenData.mac});
				}
			}
		},
		addEventListener:function(){
			var that = this;
			try{
				api.addEventListener({"name":"getYsPenDetailDataReady"},function(e){
					if($(".powerValText").length > 0){ //alert("1111");
						try{
							$(".powerValText").Label("setText",e.value.power+"%");
						}catch(e){}
					}
				});
			}catch(e){}
			$(window).bind("GET_NOTE_LINKED_PEN_DATA_SUCCESS",function(e,data){
				currPenData = data;
				$("body").find(".mainText").Label("setText",typeof(currPenData)!="undefined"?currPenData.name:"蓝牙笔");
				$(".namePanel").css("left",($(window).width()-$("body").find(".mainText").width())/2+"px");
				var linkStatus = NotePenDataModel.getLinked();
				if(typeof(currPenData)!="undefined" && currPenData.autoLink == 1){
					$('.autoLinkList').RightSwitchList("setSwitchOn");
				}
				if(currPenData && typeof(currPenData.mac) != "undefined"){
				    $("#macCode").RightTextList("changeText",currPenData.mac);
				}
			});
			
			//恢复出厂设置
			$(window).bind("BACKFACTORY_NOTE_PEN_DATA_SUCCESS",function(e,data){
				api.toast({
					msg: '恢复出厂成功',
					duration: 1000,
					location: 'middle'
				});
				Shell.sendEvent("conmmonRefresh");
				NotePenDataModel.setLocationLinkedPen("");
				//关闭窗口
				setTimeout(function(){
				    Shell.sendEvent("closeWin");
				},1500);
			});
			//解绑笔失败
			$(window).bind("BACKFACTORY_NOTE_PEN_DATA_ERROR",function(){
				 api.toast({
					msg: '网络请求失败',
					duration: 1000,
					location: 'middle'
				});
			});
			
			//解绑笔成功
			$(window).bind("UNBIND_NOTE_PEN_DATA_SUCCESS",function(e,data){
				api.toast({
					msg: '解绑成功',
					duration: 1000,
					location: 'middle'
				});
				Shell.sendEvent("conmmonRefresh");
				NotePenDataModel.setLocationLinkedPen("");
				$("body").find(".canelBindBtn").BaseBtn("setDisable");
				//关闭窗口
				setTimeout(function(){
				    Shell.sendEvent("closeWin");
				},1500);
			});
			//解绑笔失败
			$(window).bind("UNBIND_NOTE_PEN_DATA_ERROR",function(){
				 api.toast({
					msg: '网络请求失败',
					duration: 1000,
					location: 'middle'
				});
				$("body").find(".canelBindBtn").BaseBtn("setEnable");
			});
			
			try{
				api.addEventListener({"name":"loseLinkYsPen"},function(e){
					//可能收到多个事件-只触发一个飘窗-android不稳定
					if(!toastStatus){
						toastStatus = true;
						if(!needUnbind && !needBackFactory){ //既不是解除绑定,也不是恢复出厂
							api.toast({
								msg: '蓝牙连接已断开',
								duration: 1000,
								location: 'middle'
							});
							Shell.sendEvent("bluetoothOff");
							setTimeout(function(){
							    Shell.sendEvent("closeWin");
							},1500);
							//关闭窗口
							return;
							
						}
						$("body").find(".blueTeeValText").Label("setText","未连接");
						$("body").find(".closeLinkBtn").BaseBtn("setDisable");
						$(".powerValText").Label("setText","-");
						$(".refBtn").BaseBtn("setDisable");
						NotePenDataModel.setLinked(0);
						setTimeout(function(){
						    toastStatus  = false;
						},1000);
						if(needUnbind){
							needUnbind = false;
							if(currPenData && typeof(currPenData.mac) != "undefined"){
							    NotePenDataModel.unbind(currPenData.mac);
							}
						}
						if(needBackFactory){
							needBackFactory = false;
							if(currPenData && typeof(currPenData.mac) != "undefined"){
							    NotePenDataModel.backFactory(currPenData.mac);
							}
						}
					}
				});
			}catch(e){}
			try{
				//重命名成功事件
				api.addEventListener({"name":"RenameNotePenSuccess"},function(e){
					currPenData.name = e.value.name;
					$(".mainText").Label("setText",currPenData.name);
					$(".namePanel").css("left",($(window).width()-$("body").find(".mainText").width())/2+"px");
				});
			}catch(e){
			}
		},
        //生成页面方法
        create:function(){
			var header = $("<div></div>").NewHeader({"title":"设备详情","rightTitle":"修改笔密码"});
			Controller.contentHeader = header;
			header.NewHeader("setBottomLine");
			header.bind("BACK_CLICK",function(){
				//关闭窗口
				Shell.sendEvent("closeWin");
			});
			header.bind("RIGHT_CLICK",function(){
				//呼出原生修改笔密码
				if(!currPenData){
					return;
				}
				if(interWinLock){
					return;
				}
				interWinLock = true;
				if(currPenData && typeof(currPenData.mac) != "undefined"){
				    Shell.sendEvent("callYSNoteChangePenPassword",{"mac":currPenData.mac});
				}
				setTimeout(function(){
					interWinLock = false;
				},1500);
			});
			$("body").append(header);
			var scrollPanel = $("<div id='wrapper'></div>");
			scrollPanel.css("overflow","hidden");
			var ul = $("<ul></ul>");
			scrollPanel.append(ul);
			$("body").append(scrollPanel);
			
			var penStatusPanel = $("<li></li>").Panel({"width":"100%","height":"300px"});
			penStatusPanel.css("position","relative");
			penStatusPanel.Panel("setBgColor","#ffffff");
			var namePanel = $("<div class='namePanel'></div>").Panel({"width":"auto","height":"44px"});
			namePanel.css("position","absolute");
			namePanel.Panel("setLeft","149px");
			namePanel.Panel("setTop","55px");
			penStatusPanel.append(namePanel);
			var mainText = $("<div class='mainText'></div>").Label({"text":"蓝牙笔","fontSize":"18px","fontWeight":"800","letterSpacing":"2px"});
			mainText.css("float","left");
			namePanel.append(mainText);
			
			var penIcon = $("<div></div>").Img({"src":"../djcommon/img/note/pen.png","width":"173px","height":"20px"});
			penIcon.Img("setLeft","101px");
			penIcon.Img("setTop","90px");
			penIcon.css("position","absolute");
			penStatusPanel.append(penIcon);
			
			var editBtn = $("<div></div>").ImgBtn({"src":"../djcommon/img/note/edit.png","width":"12px","height":"12px"});
			setTimeout(function(){
				editBtn.css("margin-top",(mainText.height()-editBtn.height())/2+"px");
				mainText.css("line-height",mainText.height()+"px");
			},100);
			editBtn.bind("BTN_CLICK",function(){
				try{
					if(currPenData && typeof(currPenData.mac) != "undefined"){
					    Shell.sendEvent("CallRenameNotePen",{"mac":currPenData.mac,"name":currPenData.name,"url":TokenDataModel.getDomain()+NotePenDataModel.renameNameApi});
					}
				}catch(e){}
			});
			editBtn.ImgBtn("setMarginTop","7px");
			editBtn.ImgBtn("setMarginLeft","15px");
			editBtn.css("float","right");
			namePanel.append(editBtn);
			
			var buleThIcon = $("<div class='buleThIcon'></div>").Img({"src":"../djcommon/img/note/blueth.png","width":"8px","height":"14px"});
			buleThIcon.css("position","absolute");
			buleThIcon.Img("setLeft","118px");
			buleThIcon.Img("setTop","143px");
			penStatusPanel.append(buleThIcon);
			
			var blueTeeText = $("<div></div>").Label({"text":"蓝牙","fontSize":"14px","color":"#333333"});
			blueTeeText.Label("setLeft","159px");
			blueTeeText.Label("setTop","139px");
			blueTeeText.css("position","absolute");
			penStatusPanel.append(blueTeeText);
			
			var blueTeeValText = $("<div class='blueTeeValText'></div>").Label({"text":"已连接","fontSize":"12px","color":"#BCC3D6"});
			blueTeeValText.Label("setLeft","217px");
			blueTeeValText.Label("setTop","141px");
			blueTeeValText.css("position","absolute");
			penStatusPanel.append(blueTeeValText);
			
			var powerIcon = $("<div class='powerIcon'></div>").Img({"src":"../djcommon/img/note/power_icon.png","width":"8px","height":"14px"});
			powerIcon.css("position","absolute");
			powerIcon.Img("setLeft","118px");
			powerIcon.Img("setTop","168px");
			penStatusPanel.append(powerIcon);
			
			var powerText = $("<div></div>").Label({"text":"电量","fontSize":"14px","color":"#333333"});
			powerText.Label("setLeft","159px");
			powerText.Label("setTop","166px");
			powerText.css("position","absolute");
			penStatusPanel.append(powerText);
			
			var powerValText = $("<div class='powerValText'></div>").Label({"text":"获取中...","fontSize":"12px","color":"#BCC3D6"});
			powerValText.Label("setLeft","217px");
			powerValText.Label("setTop","168px");
			powerValText.css("position","absolute");
			penStatusPanel.append(powerValText);
			
			var refBtn = $("<div class='refBtn'></div>").BaseBtn({"text":"刷新","width":"74px","height":"32px","fontSize":"13px","textColor":"#999999"});
			refBtn.bind("BTN_CLICK",function(){
				Controller.getPenDetail();
			});
			refBtn.css("border-radius","3rem");
			refBtn.css("border","1px solid #999999");
			refBtn.css("position","absolute");
			refBtn.BaseBtn("setLeft","148px");
			refBtn.BaseBtn("setTop","215px");
			penStatusPanel.append(refBtn);
			
			ul.append(penStatusPanel);
			
			var bindPanel = $("<li></li>").Panel({"width":"100%","height":"auto"});
			bindPanel.Panel("setBgColor","#ffffff");
			
			var bindTitleList =  $("<div></div>").TitleList({"title":"设备绑定","fontSize":"14px","color":"#000000","fontWeight":"800","height":"40px"});
			bindPanel.append(bindTitleList);
			
			var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
			line.Panel("setBgColor","#EAEFF2");
			bindPanel.append(line);
			
			var spaceList =  $("<div></div>").RightTextList({"title":"存储空间","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px","val":maxSpace});
			bindPanel.append(spaceList);

			var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
			line.Panel("setBgColor","#EAEFF2");
			bindPanel.append(line);

			var u = navigator.userAgent;
			var macCode =  $("<div id='macCode'></div>").RightTextList({"title":"笔ID码","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px","val":"获取中..."});
			bindPanel.append(macCode);
			
			var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
			line.Panel("setBgColor","#EAEFF2");
			bindPanel.append(line);
			
			var autoLinkList =  $("<div class='autoLinkList'></div>").RightSwitchList({"title":"自动连接","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px"});
			autoLinkList.bind("SWITCH_CHANGED",function(e,data){
				if(data.status == "on"){
					currPenData.autoLink = 1;
				}else{
					currPenData.autoLink = 0;
				}
				NotePenDataModel.setLocationLinkedPen(currPenData);
			});
			bindPanel.append(autoLinkList);
			
			var line = $("<div></div>").Panel({"width":"100%","height":"4px"});
			line.Panel("setBgColor","#EAEFF2");
			bindPanel.append(line);
			ul.append(bindPanel);
			
			var otherPanel = $("<li></li>").Panel({"width":"100%","height":"auto"});
			otherPanel.Panel("setBgColor","#ffffff");
			
			var otherTitleList =  $("<div></div>").TitleList({"title":"其他信息","fontSize":"14px","color":"#000000","fontWeight":"800","height":"40px"});
			otherPanel.Panel("addElement",otherTitleList);
			
			var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
			line.Panel("setBgColor","#EAEFF2");
			otherPanel.Panel("addElement",line);
			
			var DescList =  $("<div></div>").RightEnterList({"title":"使用说明","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px"});
			otherPanel.Panel("addElement",DescList);
			DescList.bind("LIST_CLICK",function(){
		        Shell.sendEvent("openWin",{"url":"/notependesc/notePenDesc.html","open_type":true,"title":"使用说明"});
			});
			
			var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
			line.Panel("setBgColor","#EAEFF2");
			otherPanel.Panel("addElement",line);
			
			var deviceList =  $("<div></div>").RightEnterList({"title":"设备信息","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px"});
			otherPanel.Panel("addElement",deviceList);
			deviceList.bind("LIST_CLICK",function(){
		        Shell.sendEvent("openWin",{"url":"/notependevice/notePenDevice.html","open_type":true,"title":"使用说明"});
			});
			
			var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
			line.Panel("setBgColor","#EAEFF2");
			otherPanel.Panel("addElement",line);
			var isSelf;
			try{
				isSelf = api.getPrefs({
					sync: true,
					key: 'isSelfBind'
				});
			}catch(e){}
			var backFactoryList =  $("<div></div>").RightEnterList({"title":"恢复出厂设置","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px"});
			if(isSelf == "1"){
				otherPanel.Panel("addElement",backFactoryList);
			}
			backFactoryList.bind("LIST_CLICK",function(){
		       //恢复出厂设置
			   try{
					api.addEventListener({"name":"AlertHasBeedClick"},function(e){
						api.removeEventListener({"name":"AlertHasBeedClick"});
						if(e.value.index == 1){
							var val = NotePenDataModel.getLinked();
							if(val == 1){  //连接中,需要先断开连接
								$("body").find(".closeLinkBtn").BaseBtn("setDisable");
								$("body").find(".canelBindBtn").BaseBtn("setDisable");
								try{
									needBackFactory = true;
									if(currPenData && typeof(currPenData.mac) != "undefined"){
									    Shell.sendEvent("cancelLinkYsPen",{"mac":currPenData.mac});
									}
								}catch(e){}
							}else{
								$("body").find(".canelBindBtn").BaseBtn("setDisable");
								if(currPenData && typeof(currPenData.mac) != "undefined"){
								    Controller.backFactory(currPenData.mac);
								}
							}
						}
					});
					Shell.sendEvent("ShowMeTheAlert",{"title":"此操作会清空所有离线数据以及重置连接密码，是否确认操作？","btn":["取消","确认"]});
				}catch(e){}
			});
			ul.append(otherPanel);
			
			btnPanel = $("<li></li>").Panel({"width":"100%","height":"100px"});			
			btnPanel.Panel("setBottom","0px");
			btnPanel.Panel("setBgColor","#ffffff");
			btnPanel.css("position","fixed");
			var canelBindBtn = $("<div class='canelBindBtn'></div>").BaseBtn({"text":"删除设备","width":"165px","height":"44px","fontSize":"16px","textColor":"#C82128"});
			canelBindBtn.bind("BTN_CLICK",function(){
												   
				try{
					api.addEventListener({"name":"AlertHasBeedClick"},function(e){
						api.removeEventListener({"name":"AlertHasBeedClick"});
						if(e.value.index == 1){
							var val = NotePenDataModel.getLinked();
							if(val == 1){  //连接中,需要先断开连接
								$("body").find(".closeLinkBtn").BaseBtn("setDisable");
								$("body").find(".canelBindBtn").BaseBtn("setDisable");
								try{
									needUnbind = true;
									if(currPenData && typeof(currPenData.mac) != "undefined"){
									    Shell.sendEvent("cancelLinkYsPen",{"mac":currPenData.mac});
									}
								}catch(e){}
							}else{
								$("body").find(".canelBindBtn").BaseBtn("setDisable");
								Controller.unbind();
							}
							NotePenDataModel.setLocationLinkedPen("");
						}
					});
					Shell.sendEvent("ShowMeTheAlert",{"title":"解除绑定后将断开连接并且下次连接时需要重新输入密码，确定要解绑吗？","btn":["取消","确认"]});
				}catch(e){}
			});
			canelBindBtn.css("border-radius","3rem");
			canelBindBtn.css("border","1px solid #CF000F");
			canelBindBtn.css("position","absolute");
			canelBindBtn.BaseBtn("setLeft","15px");
			canelBindBtn.BaseBtn("setTop","28px");
			var closeLinkBtn = $("<div class='closeLinkBtn'></div>").BaseBtn({"text":"断开连接","width":"165px","height":"44px","fontSize":"16px","textColor":"#ffffff","bgColor":"#CF000F"});
			closeLinkBtn.css("border-radius","3rem");
			closeLinkBtn.css("border","1px solid #CF000F");
			closeLinkBtn.css("position","absolute");
			closeLinkBtn.BaseBtn("setRight","15px");
			closeLinkBtn.BaseBtn("setTop","28px");
			closeLinkBtn.bind("BTN_CLICK",this,this.onCloseLinkBtnClick);
			
			btnPanel.Panel("addElement",canelBindBtn);
			btnPanel.Panel("addElement",closeLinkBtn);
			btnPanel.Panel("addElement",$("<div style='clear:both'></div>"));
			$("body").append(btnPanel);
			
			setTimeout(function(){
				scrollPanel.css({"width":"100%","height":$(window).height()-header.offset().top-header.height()-btnPanel.height()+"px"});
				scrollPanel.css("position","relative");
				ul.css("min-height",parseInt(scrollPanel.css("height").replace("px",""))+1+"px");
				ul.css("width","100%");
				ul.css("position","absolute");
				//初始化滚动插件
				myScroll = new IScroll("#wrapper",{
					bounceTime:300,//配置滑动回弹时间
					bounce:true,
					probeType:3,
					momentum:true,
				});
				myScroll.on("scrollStart",function(){
					Shell.sendEvent("LockSwitchActivity");
				});
				myScroll.on("scrollEnd",function(){
					Shell.sendEvent("unLockSwitchActivity");
				});
				window.myScroll = myScroll;
				myScroll.refresh();
			},200);
			
		},
		onCloseLinkBtnClick:function(e){
			try{
				api.addEventListener({"name":"AlertHasBeedClick"},function(e){
					api.removeEventListener({"name":"AlertHasBeedClick"});
					if(e.value.index == 1){
						$("<div id='msk' style='width:100%;height:100%;z-index:100000000000;position:fixed;top:0;left:0;'></div>").appendTo($("body"));
						$("body").find(".closeLinkBtn").BaseBtn("setDisable");
						try{
							if(currPenData && typeof(currPenData.mac) != "undefined"){
							    Shell.sendEvent("cancelLinkYsPen",{"mac":currPenData.mac});
							}
						}catch(e){}
					}
				});
				Shell.sendEvent("ShowMeTheAlert",{"title":"断开连接数据将不更新到智能本，是否继续？","btn":["取消","确认"]});
			}catch(e){}
		}
    }
    
    return Controller;
});
