/*
*   2020年12月8日
*
*   笔详情-使用说明的js控制器
*
*   开发者：薛原
*/
define(["jquery","Shell","Fastclick","Config","iscroll","NewHeader","Panel","Label","RightTextList"], function ($,Shell,Fastclick,Config,IScroll) {
    var Controller = {
        init:function(){
			
            Controller.create();//调用生成页面方法
			Config.adapter.setBaseRem();
			//通知原生关闭加载动画
			setTimeout(function(){
				Shell.sendPageReady();
			},100);
        },
        //生成页面方法

		create:function(){
			$("body").css({"overflow":"hidden","font-family":"PingFang SC","color":"#333333"});
			var header = $("<div style='border-bottom: 1px #ececec solid'></div>").NewHeader({"title":"设备信息"});
			header.bind("BACK_CLICK",function(){
				//关闭窗口
				Shell.sendEvent("closeWin");
			});
			$("body").append(header);
			
			var scrollPanel = $("<div id='wrapper'></div>");
			scrollPanel.css("overflow","hidden");
		
			var list1 =  $("<div></div>").RightTextList({"title":"重量","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px","val":"24.5g"});
			var list2 =  $("<div></div>").RightTextList({"title":"充电时长","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px","val":"2小时"});
			var list3 =  $("<div></div>").RightTextList({"title":"电池","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px","val":"Li-ion(内置)3.7V 250mAH"});
			var list4 =  $("<div></div>").RightTextList({"title":"笔芯尺寸","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px","val":"67.0mm × 2.3mm"});
			var list5 =  $("<div></div>").RightTextList({"title":"数据传输","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px","val":"Bluetooth4.2"});
			var list6 =  $("<div></div>").RightTextList({"title":"工作时间","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px","val":"连续书写8小时"});
			var list7 =  $("<div></div>").RightTextList({"title":"待机时间","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px","val":"50天"});
			var list8 =  $("<div></div>").RightTextList({"title":"支撑平台","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px","val":"Android 4.4及以上"});
			var list9 =  $("<div></div>").RightTextList({"title":"点阵笔尺寸","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px","val":"156.2mm × 10.5mm × 10.5mm"});
			var list10 =  $("<div></div>").RightTextList({"title":"传输距离","fontSize":"16px","color":"#000000","fontWeight":"500","height":"54px","val":"<10m"});
			
			setTimeout(function(){
				scrollPanel.css({"width":"100%","height":$(window).height()-header.offset().top-header.height()+"px"});
				$("body").append(scrollPanel);
				var ul = $("<div></div>");
				scrollPanel.append(ul);
				ul.append(list1);
				var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
				line.css("height","1px");
				line.Panel("setBgColor","#EAEFF2");
				ul.append(line);
				ul.append(list2);
				var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
				line.css("height","1px");
				line.Panel("setBgColor","#EAEFF2");
				ul.append(line);
				ul.append(list3);
				var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
				line.css("height","1px");
				line.Panel("setBgColor","#EAEFF2");
				ul.append(line);
				ul.append(list4);
				var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
				line.css("height","1px");
				line.Panel("setBgColor","#EAEFF2");
				ul.append(line);
				ul.append(list5);
				var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
				line.css("height","1px");
				line.Panel("setBgColor","#EAEFF2");
				ul.append(line);
				ul.append(list6);
				
				var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
				line.css("height","1px");
				line.Panel("setBgColor","#EAEFF2");
				ul.append(line);
				ul.append(list7);
				
				var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
				line.css("height","1px");
				line.Panel("setBgColor","#EAEFF2");
				ul.append(line);
				ul.append(list8);
				
				var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
				line.css("height","1px");
				line.Panel("setBgColor","#EAEFF2");
				ul.append(line);
				ul.append(list9);
				
				var line = $("<div></div>").Panel({"width":"100%","height":"1px"});
				line.css("height","1px");
				line.Panel("setBgColor","#EAEFF2");
				ul.append(line);
				ul.append(list10);
				ul.css("min-height",parseInt(scrollPanel.css("height").replace("px",""))+1+"px");
				var myScroll = new IScroll("#wrapper",{
					bounceTime:300,
					probeType:3,
				});
				myScroll.on("scrollStart",function(){
					Shell.sendEvent("LockSwitchActivity");
				});
				myScroll.on("scrollEnd",function(){
					Shell.sendEvent("unLockSwitchActivity");
				});
				myScroll.refresh();
			},200);
			
			//解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
			
		}
    }
    
    return Controller;
});
