/*
 * BtnGroup  按钮组件 
 * 按钮组为按钮的组合，控制按钮选中互斥逻辑
 * @Author Zhang    
 * @Date 2019/01/15    
*/
define(['Widget'],function(require, exports){     
    $.widget("ys.BtnGroup", $.ys.Widget, {   
        btnList:[], //按钮        
        _init: function () {
            this._super();   
        },
        addBtn:function(element){  //添加按钮组件  
            this.element.append(element);   
            this.btnList.push(element);
            element.bind("BTN_CLICK", this, this._btnClick);
        }, 
        _btnClick:function(e){     
            for (var index = 0; index < e.data.btnList.length; index++) {  
                if(e.data.btnList[index].text() == $(this).text()){       
                    e.data.btnList[index].trigger("SET_BTNACTIVE_CLICK", index);    
                } 
            }     
        },
        getBtnGroup:function(){ //获取按钮组  
            return this.btnList;         
        },
        //创建控件，控件生命周期内会运行多次
        _create: function () {},
        // 释放控件
        destroy: function () {
            $.Widget.prototype.destroy.call(this);
        }
    });
})