define(function (){


    return  {
        _extentions:{
            folder:['folder'],
			share_folder_base:['share_folder_base'], //普通共享
			share_folder_cross_org:['share_folder_cross_org'], //跨组织共享
            pdf:['pdf'],
            txt:["curl","dcurl","mcurl","scurl","sub","fly","flx","gv","3dml","spot","jad","wml","wmls","s", "asm","c", "cc", "cxx", "cpp", "h", "hh", "dic"
                 ,"htc","f", "for", "f77", "f90","hbs","java","lua","mkd","nfo","opml","*org","p", "pas","pde","sass","scss","etx","sfv","ymp","uu","vcs",
                "vcf","dsc","appcache", "manifest","ics", "ifb","coffee", "litcoffee","css","csv","html", "htm", "shtml","jade","jsx","less","markdown", 
                "md","mml","n3","txt", "text", "conf", "def", "list", "log", "in", "ini","rtx","*rtf","sgml", "sgm", "shex","slim", "slm","stylus", "styl",
                "tsv","t", "tr", "roff", "man", "me", "ms","ttl","uri", "uris", "urls","vcard","vtt","*xml","yaml", "yml","js"],
            
            document:["doc", "dot","wps", "wks", "wcm", "wdb","docx","dotx"],
         
            xls:["xls", "xlm", "xla", "xlc", "xlt", "xlw","xlam","xlsb","xlsm","xltm","xlsx","xltx"],
            
            ppt:["ppt", "pps", "pot", "ppam", "pptm", "sldm","ppsm","potm","pptx","sldx","ppsx"],
            
            img: ["btif","pti","psd","azv","uvi","uvvi","uvg","uvvg","djvu","djv","*sub","dwg","dxf","fbs","fpx","fst","mmr","rlc","ico",
                "mdi","wdp","npx","tap","vtf","wbmp","xif","pcx","3ds","ras","cmx","fh", "fhc", "fh4", "fh5", "fh7","*ico","jng","sid","*bmp",
                "*pcx","pic", "pct","pnm","pbm","pgm","ppm","rgb","tga","xbm","xpm","xwd","exr","apng","bmp","cgm","drle","emf","fits","g3","gif",
                "heic","heics","heif","heifs","ief","jls","jp2", "jpg2","jpeg", "jpg", "jpe","jpm","jpx", "jpf","ktx","png","sgi","svg", "svgz",
                "t38","tif", "tiff","tfx","webp","wmf","jpg"],
            
             audio:["uva", "uvva","eol","dra","dts","dtshd","lvp","pya","ecelp4800","ecelp7470","ecelp9600","rip","aac","aif", "aiff", "aifc",
                    "caf","flac","*m4a","mka","m3u","wax","wma","ram", "ra","rmp","*ra","*wav","*3gpp","adp","au", "snd","mid", "midi", "kar", 
                    "rmi","*mp3","m4a", "mp4a","mpga", "mp2", "mp2a", "mp3", "m2a", "m3a","oga", "ogg", "spx","s3m","sil","wav","*wav","weba",
                    "xm","MP3"],
        
            video:  ["uvh", "uvvh","uvm", "uvvm","uvp", "uvvp","uvs", "uvvs","uvv", "uvvv","dvb","fvt","mxu", "m4u","pyv"
                    ,"uvu","uvvu","viv","f4v","fli","flv","m4v","mkv", "mk3d", "mks","mng","asf", "asx","wm","wmv","wmx","wvx","avi",
                    "movie","smv","3gp", "3gpp","3g2","h261","h263","h264","jpgv","*jpm", "jpgm","mj2", "mjp2","ts","mp4", "mp4v", "mpg4",
                    "mpeg", "mpg", "mpe", "m1v", "m2v","ogv","qt", "mov","webm","MP4","rmvb"],//"vob",@薛原 不管吧，就把主流的归到视频即可
           
            bt:  ["torrent"],
            zip: ["zip","gz","tar","rar","bz","bz2", "boz","7z"],
            ysnote:["ysnote"],
            exe:["exe"],
            ysnote:["ysnote"],
            
        },
        getName:function(extentionName) {
            var x,ext = this._extentions,name = extentionName.toLowerCase();
            for(x in ext){
                if(ext[x].indexOf(name)>-1 ){
                    ext = void 0;name = void 0;
                    return x;
                }
            }
            ext = void 0;name = void 0;
            return "unknown"
        },
        _iconUrl:{
            folder:"/assets/img/appimg/Cloud/file_icon_f@3x.png",
			share_folder_base:"/assets/img/appimg/Cloud/sharespace_icon_zzw@2x.png",
			share_folder_cross_org:"/assets/img/appimg/Cloud/sharespace_icon_zzn@2x.png",
            bt:"/assets/img/appimg/Cloud/file_icon_bt@3x.png",
            audio:"/assets/img/appimg/Cloud/file_icon_music@3x.png",
            video:"/assets/img/appimg/Cloud/file_icon_sp@3x.png",
            xls:"/assets/img/appimg/Cloud/file_icon_xxs@3x.png",
            document:"/assets/img/appimg/Cloud/file_icon_word@3x.png",
            ppt:"/assets/img/appimg/Cloud/file_icon_ppt@3x.png",
            img:"/assets/img/appimg/Cloud/file_icon_pt@3x.png",
            pdf:"/assets/img/appimg/Cloud/file_icon_pdf@3x.png",
            txt:"/assets/img/appimg/Cloud/file_icon_txt@3x.png",
            zip:"/assets/img/appimg/Cloud/file_icon_ys@3x.png",
            exe:"/assets/img/appimg/Cloud/file_icon_qt@3x.png",
            ysnote:"/assets/img/appimg/Cloud/file_icon_ysnote@3x.png",
            unknown:"/assets/img/appimg/Cloud/file_icon_weishibie@3x.png"
        },
        getIcon:function(extentionName){
            var icon = this.getName(extentionName);
            return icon in this._iconUrl ? this._iconUrl[icon] : this._iconUrl.unknown;
        }

     
    }
});
