/*
	皮肤管理器
	皮肤管理器主要以过滤器模型进行皮肤处理
	付长建
 */
define([],function(require, exports){
	var SkinManager = {};
	//检测图片，如果检测到有皮肤配置，则会被替换成皮肤图片
	SkinManager.CheckImg = function(key,val){
		if(global.skin_img_config && global.skin_img_config[key]){
			var imgPath = global.skin_img_config[key];
			imgPath = imgPath.replace("/assets/img/appimg/","../djcommon/img/");
			return imgPath;
		}
		return val;
	}
	//检测文字，如果检测到有皮肤配置，则会被替换成皮肤文字
	SkinManager.CheckTxt = function(key,val){
		if(global.skin_txt_config && global.skin_txt_config[key]){
			return global.skin_txt_config[key];
		}
		return val;
	}
	//检测字体颜色，如果检测到有皮肤配置，则会被替换成皮肤文字颜色
	SkinManager.CheckColor = function(key,val){
		if(global.skin_color_config && global.skin_color_config[key]){
			return global.skin_color_config[key];
		}
		return val;
	}
	return SkinManager;
});