define(function () {
  return function (type) {
    try {
      var u = navigator.userAgent;
      var isIOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
      if (isIOS) {
        switch (type) {
          case "top-compatible":{//兼容安卓和ios，安卓壳是从安全区域渲染，ios是从顶部渲染
            return api.safeArea.top;
          }
          case "bottom-compatible":{//兼容安卓
            return api.safeArea.bottom;
          }
          case "top": {
            return api.safeArea.top;
          }
          case "bottom-noBar": {
            return api.safeArea.bottom;
          }
          case "bottom": {
            return api.safeArea.bottom;
          }
          default: {
            return api.safeArea.top;
          }
        }
      } else {
        switch (type) {
          case "top-compatible": {
            return 0;
          }
          case "bottom-compatible": {
            return 0;
          }
          case "top": {
            return api.safeArea.top;
          }
          case "bottom-noBar": {
            return api.safeArea.bottom;
          }
          case "bottom": {
            return api.safeArea.bottom;
          }
          default: {
            return api.safeArea.top;
          }
        }
      }
    } catch (e) {
      console.warn(e);
      return 0
    }

  }
});