/*
*   2020年12月3日
*   
*   下拉菜单组件
*
*   开发者：薛原 
*/
define(["Panel","Label",'TextBtn'],function(){
    $.widget("ys.DownMenu",$.ys.Panel,{
        //默认参数
        options:{},
		_baseHeight:0,
		_baseWidth:0,
		_baseLeft:0,
		_baseTop:0,
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
			this.setBorderRadius("10px");
			this.setWidth(this.options.width?this.options.width:"110px");
			this.setHeight(this.options.height?this.options.height:"80px");
			this.setMarginLeft("30px");
			this.setMarginRight("30px");
			this.setBgColor("#ffffff");
            this.element.css({"box-shadow":"0px 2px 12px 3px rgba(188, 191, 194, 0.2)"});
			for(var i=0;i<this.options.options.length;i++){
				var el = $("<div class='el'></div>").TextBtn({"text":this.options.options[i],"width":"100%","height":"40px","fontSize":"15px"});
				el.find("div").addClass("btn-text");
				el.attr("data-index",i);
				if(i != 0){
					var line = $("<div class='el'></div>").Panel({"width":"100%","height":"2px"});
					line.css("border-top","1px solid #dfdfdf");
					line.css("opacity",0);
					this.element.append(line);
				}
				el.TextBtn("setPaddingLeft","15px");
				el.css("opacity",0);
				el.TextBtn("setPaddingRight","15px");
				el.bind("BTN_CLICK",this,this.onBtnClick);
				this.element.append(el);
			}
			
			//alert(this._baseWidth+"|"+this._baseHeight);
			this.css("opacity",0);
        },
		onBtnClick:function(e){
			e.data.element.trigger("OPTION_CHOOSE",{"index":$(this).attr("data-index")});
		},
		show:function(){
			if(!this._baseWidth){
				this._baseWidth = $(this.element).width();
				this._baseHeight = $(this.element).height();
				this._baseLeft = $(this.element).offset().left;
				this._baseTop = $(this.element).offset().top;
				this.element.css("top",this._baseTop+"px");
			}else{
				if(this.element.width() != 0){
					return;
				}
			}
			//alert(this._baseWidth+"|"+this._baseHeight);
			this.element.css("left",this._baseLeft+this._baseWidth+"px");
			this.setWidth("0px");
			this.setHeight("0px");
			var that = this;
			$(this.element).animate({"left":this._baseLeft+"px","width":this._baseWidth+"px","height":this._baseHeight+"px","opacity":1},"20000",function(){
			    that.element.find(".el").css("opacity",1);
			});
			
			setTimeout(function(){
			    $(window).unbind("touchstart").bind("touchstart",that,that.onTouchStart);
			},500);
			
		},
		hide:function(){
			this.element.find(".el").css("opacity",0);
			$(window).unbind("touchstart");
			this.element.trigger("CLOSE");
			this.element.remove();
			
		},
		onTouchStart:function(e){
			if($(e.target).hasClass(e.data.options.target)){
			}else if($(e.target).hasClass('btn-text')){
			}else{
			    e.data.hide();
			}
		},
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});