/*
 * @Author: wen
 * @Date: 2019-3-04 10:39:19
 * 没有内容时的显示页面
 */

define(['SkinManager','Img','Label','Btn','style','SubmitBtn'],function(skinManager,require, exports){
    $.widget("ys.EmptyPanel",$.ys.Widget, {
        //默认参数//默认参数
        //初始化，控件生命周期内只运行一次
        _nolabel:null,
        _noImage:null,
        _btn:null,
        _init: function () {
            this._super();
            this.element.css("overflow","hidden");
            this._noImage = $("<div class='noImage'></div>");
			this._noImage.Img({"src":this.options.src,"width":"200px","height":"120px"});
			this._noImage.style({"margin-top":"69px","margin-left":"88px"});
            this._noImage.appendTo(this.element);
            this._nolabel = $("<div id='title'></div>");
			this._nolabel.Label({"text":this.options.title,"color":"#999999","fontSize":"14px"});
            this._nolabel.Label("setWidth","100%");
            this._nolabel.css({"margin-top":23*this.s+"rem","text-align":"center"})
            this.element.append(this._nolabel);

            if(this.options.btnTitle){
                this._btn = $("<div id='empty-btn'></div>").SubmitBtn({"width":"125px","height":"40px","bgColor":skinManager.CheckColor("tableview_empty_color","#367BD6"),"borderRadius":"25px"})
                this._btn.style({"margin-left":'125px',"margin-top":'45px'})
                this._btn.html(this.options.btnTitle);
                this._btn.appendTo(this.element);
                this._btn.bind("BTN_CLICK",this,this._clickButton);
            }
            
        },
        _clickButton:function(e){

            e.data.element.trigger("ADD_FILE_CLICK");
        },
        //创建控件，控件生命周期内会运行多次
        _create: function () {},
        // 释放控件
        destroy: function () {
            $.Widget.prototype.destroy.call(this);
        }
    });
})
