/*
*   2020年12月16日
*   
*   封装保险箱笔记转文档底部导航组件
*
*   开发者：付长建 
*/
define([],function(){
    $.widget("ys.FootBottom",{
        //默认参数
        options:{},
        _isClick:false,//时候可以点击全选按钮
        //创建控件，控件生命周期内会运行多次 
        _create:function(){
            this.element.css({
                "width":"100%",
                "padding-bottom":phonexh("bottom") == 0 ? 0 : "0.2rem",
                "box-sizing":"border-box",
                "box-shadow":"rgba(0,37,87,0.3) 0px 15px 25px 5px"
            });
            var contentContainer = $("<div style='width:100%;height:0.49rem;padding:0 0.15rem 0 0.15rem;box-sizing:border-box;display:flex;flex-direction:row;align-items:center;justify-content:space-between;'></div>").appendTo(this.element);
            //创建全选和反选元素
            this._allSelectContainer = $("<div style='height:100%;display:flex;flex-direction:row;'></div>").appendTo(contentContainer);
            var div = $("<div isData='no' style='height:100%;display:flex;align-items:center;'></div>").appendTo(this._allSelectContainer);
            $("<img style='width:0.16rem;height:0.16rem;' src='"+skinConfig(global.skin).commonIcon+"pt_touxuan.png'/>").appendTo(div);
            $("<span style='font-size:0.12rem;margin-left:0.1rem;'>全选</span>").appendTo(div);
            $("<p style='font-size:0.12rem;margin-left:0.2rem;display:flex;align-items:center;'>已选中 <span>0</span> 页</p>").appendTo(this._allSelectContainer);
            //创建提示
            $("<p style='font-size:0.12rem;font-weight:bold;'>请选择要转换的页码</p>").appendTo(contentContainer);  

            //给勾选按钮绑定点击事件
            div.bind("click",this,this._selectClick);
            // this._isClick = true;
        },
        //点击勾选按钮
        _selectClick:function(event){
            if(event.data._isClick){
                if($(this).attr("isData") == "no"){
                    $(this).attr("isData","yes");
                    $(this).find("img").attr("src",skinConfig(global.skin).shllWebIon + "pt_touxuan.png");
                    event.data._allSelectContainer.find("span").html("反选");
                }else{
                    $(this).attr("isData","no");
                    $(this).find("img").attr("src",skinConfig(global.skin).commonIcon + "pt_touxuan.png");
                    event.data._allSelectContainer.find("span").html("全选");
                }
            }
            event.data.element.trigger("ALL_SELECT",$(this).attr("isData"));//抛出全选事件和全不选事件
        },
        //设置允许全选按钮点击方法
        allowClick:function(){
            this._isClick = true;
        },
        //设置选中数量
        setSelectNumm:function(numm){
            // alert('设置选中数量 numm' + numm)
            this._allSelectContainer.find("p").children("span").html(numm);
        },
        //设置选中和不选择方法
        changeAllSelect:function(type){
            if(type == "yes"){
                this._allSelectContainer.find("div").attr("isData","yes");
                this._allSelectContainer.find("img").attr("src",skinConfig(global.skin).shllWebIon + "pt_touxuan.png");
                this._allSelectContainer.find("span").html("反选");
            }else{
                this._allSelectContainer.find("div").attr("isData","no");
                this._allSelectContainer.find("img").attr("src",skinConfig(global.skin).commonIcon + "pt_touxuan.png");
                this._allSelectContainer.find("span").html("全选");
            }
        },
        //锁住底部操作
        lock:function(type){
            if(type == "yes"){
                this.element.css({"pointer-events":"none","opacity":"0.5"});
            }else{
                this.element.css({"pointer-events":"","opacity":""});
            }
        },
        //释放控件(清除控件)
        destroy:function(){
            $.Widget.prototype.destroy.call(this); 
        }
    });
});