
define(['SkinManager','phonexh','Btn','ImgBtn','Widget','style'],function(skinManager,phonexh, exports){
	$.widget("ys.Header",$.ys.Widget,{
        _headerLeft:null,
        _headerTitle:null,
        _headerRight:null,
		//默认参数
		//初始化，控件生命周期内只运行一次
		_init: function () {
            this._super();
           
            if(typeof this.options.showSafeArea === 'undefined'){
                //次参数主要是兼容安卓，底部导航页面使用header组件时，此参数应该为true，ios默认为true
                this.options.showSafeArea = navigator.userAgent.toLowerCase().indexOf('android')>-1 ? false : true; 
            }
            var top = 0;
			this.element.style({"width":"100%","height":top+44+"px","position":"relative","background":"#fff","overflow":"hidden","z-index":20000});
			try{
				if(api.safeArea.top){
                    top = api.safeArea.top;
					this.element.css("height",api.safeArea.top + 44+"px");
				}
			}catch(e){
			}
            if(this.options.bgColor != ""){
                this.element.css("background",this.options.bgColor); 
            }

            if(this.options.shadow === true){
                this.element.css({"boxShadow":"0px 6px 9px 2px rgba(0,37,87,0.06)"});
            }

            /*try{
                if(global.skin_name != "dangjian"){
                    //设置电池条字体颜色
                    api.setStatusBarStyle(typeof this.options.statusBar === 'object' ? this.options.statusBar : {style : 'dark',color : 'rgb(255,255,255)'});//{style : 'dark',color : 'rgba(0,0,0,0.0)'});
                }
            }catch(e){
                console.warn(e)
            }
			*/
            if(this.options.leftTitle){
                this._headerLeft = $("<div class='lefttBtn'></div>");
                this._headerLeft.css({"position":"absolute","top":top+"px","bottom":"0","left":"0","width":"6rem","padding-left":"1rem","height":"44px","line-height":"44px",
            "font-size":"0.9375rem","color":this.options.leftColor})
                this._headerLeft.html(this.options.leftTitle)
                this._headerLeft.Btn();
            }else{
                var leftImg = this.options.leftSrc?this.options.leftSrc:"../djcommon/img/icon_back@3x.png"
                this._headerLeft = $("<div></div>")
                if(this.options.backgroundSize != undefined){
                    this._headerLeft.css({"z-index":"2","position":"absolute","top":top+"px","bottom":"0","left":"0","width":"4rem","height":"44px","line-height":"44px","background":"url("+leftImg+")",
                    "backgroundSize":"0.1rem 0.17rem","backgroundPosition":"7% 50%","backgroundRepeat":"no-repeat"})
                }else{
                    this._headerLeft.css({"position":"absolute","top":top+"px","bottom":"0","left":"0","width":"4rem","height":"44px","line-height":"44px","background":"url("+leftImg+")",
                    "backgroundSize":"0.5625rem 0.9375rem","backgroundPosition":"25% 50%","backgroundRepeat":"no-repeat"})
                }
                
                this._headerLeft.Btn();
                
            }
            this.element.append( this._headerLeft);
           //1.8288rem
            this._headerTitle = $("<div></div>");
            if(this.options.backgroundSize != undefined){
                this._headerTitle.css({"position":"absolute","top":top+"px","bottom":"0","left":"0","width":"100%","height":"44px","line-height":"44px","color":"#333333",
                "textAlign":"center","fontWeight":"bold","whiteSpace":"nowrap","overflow":"hidden","textOverflow":"ellipsis"}).style({"fontSize":"17px"})
            }else{
                this._headerTitle.css({"position":"absolute","top":top+"px","bottom":"0","left":"0","width":"11.43rem","height":"44px","line-height":"44px","color":"#333333",
                "textAlign":"center","fontWeight":"bold","whiteSpace":"nowrap","overflow":"hidden","textOverflow":"ellipsis"}).style({"fontSize":"17px"})
            }
			
            if(this.options.textColor){
                this._headerTitle.css("color",this.options.textColor)
            }
            this._headerTitle.html(this.options.title);
            this.element.append(this._headerTitle); 

            var rightImg = this.options.rightSrcs?this.options.rightSrcs:"../djcommon/img/tabbar_icon_add@3x.png"
            if(this.options.rightSrc){
                this._headerRight = $("<div id='rightIconBtn'></div>");
                this._headerRight.css({"position":"absolute","top":top+"px","bottom":"0","right":"0px","width":"3.125rem","line-height":"44px","height":"44px","background":"url("+rightImg+")",
                "backgroundSize":"1rem 1rem","backgroundPosition":"50% 50%","backgroundRepeat":"no-repeat"})
                this._headerRight.Btn();
                this.element.append( this._headerRight);
                this._headerRight.bind("BTN_CLICK",this,this.rightBtnClick);
            }
            if(this.options.rightTitle){
                this._headerRight = $("<div class='rightBtn'></div>");
                var cssRight = {"position":"absolute","top":top+"px","right":"0","font-size":"0.9375rem","width":"6rem","padding-right":"1rem","hieght":"44px","line-height":"44px","text-align":"right","color":skinManager.CheckColor('cloud_choosed_titlecolor_color',"#333333")};
                if(this.options.rightColor){
                    cssRight.color = this.options.rightColor;
                }
                if(this.options.rightFontWeight){
                    cssRight.fontWeight = this.options.rightFontWeight;
                }
                this._headerRight.css(cssRight)
                this._headerRight.html(this.options.rightTitle)
                this._headerRight.Btn();
                this.element.append( this._headerRight);
                this._headerRight.bind("BTN_CLICK",this,this.rightBtnClick);
                
                if(this.options.rightWeight){
                    this._headerRight.css("font-weight",this.options.rightWeight);
                }
            }
            if(this.options.leftHide === true){
                this.setLeftHide();
            }
            if(this.options.rightEnable === false){
                this.setRightDisable();
            }

            this._headerLeft.bind("BTN_CLICK",this,this.backBtnClick);
			var that = this;
			that._headerTitle.hide();
			setTimeout(function(){
				that._headerTitle.css("left",($(window).width()-that._headerTitle.width())/2+"px");
				that._headerTitle.show();
			},100);
			
			this._headerTitle.css("left",($(window).width()-this._headerTitle.width())/2+"px");
        },
        setTitle:function(string){
            this._headerTitle.html(string);
        },
        setLeftTitle:function(string){
            this._headerLeft.html(string);
        },
        setLeftHide:function(){
            this._headerLeft.hide();
        },
        setLeftShow:function(){
            this._headerLeft.show();
        },
        setRightHide:function(){
            this._headerRight.hide();
        },
        setRightShow:function(){
            this._headerRight.show();
        },
        setRightDisable:function(){
            this._headerRight.Btn('setDisable');
        },
        setRightEnable:function(){
            this._headerRight.Btn('setEnable');
        },
        setRigntColor:function(color){
            this._headerRight.css(color);
        },
        backBtnClick:function(e){
            e.data.element.trigger("BACK_CLICK");
        },
		rightBtnClick:function(e){
            e.data.element.trigger("RIGHT_CLICK");
        },
        //给页面js控制器提供一个修改head的方法
        changeHeadTitle:function(setNumm){
            this._headerTitle.html("已选中" + setNumm + "项");
        },
        changeHeadTitles:function(text){
            this._headerTitle.html(text);
        },
		//创建控件，控件生命周期内会运行多次
		_create: function () {},
		// 释放控件
		destroy: function () {
			$.Widget.prototype.destroy.call(this);
		}
	});
})