/*
 * BaseBtn 图片按钮类
 * 作者：薛原
*/
define(['Btn','Img'],function(require, exports){
	$.widget("ys.ImgBtn",$.ys.Btn, {
		//默认参数
		_label:null,
		_status:0,
		//初始化，控件生命周期内只运行一次
		_init: function () {
			this._super();
			if(this.options.src){
				this._img = $("<div></div>");
				this._img.Img({"src":this.options.src,"width":this.options.width,"height":this.options.height});
				this.element.append(this._img);
			} 
			if(this.options.status){
				this._status = this.options.status; 
			}
			if(this.options.tapStatus){
				this._status = this.options.tapStatus; 
				this.setStatusSrc(this.options.tapStatus);
			}
			this.element.attr("status",this._status)
		},
		getStatus:function(){
			return this._status;
		},
		setSize:function(obj){
			this.element.css(obj);
			this._img.css(obj);
			this._img.Img("setSize",obj);
		},
		setImgSrc:function(){ //切换图片
			
			if(this._status == 0){
				this._status = 1;
			}else{
				this._status = 0;
			}
			this.element.attr("status",this._status)
			var src = this._status==0 ? this.options.src:this.options.tapSrc;
			this._img.Img("changeSrc",src);
		},
		setStatusSrc:function(int){ //切换图片
			
			this._status = int;
			this.element.attr("status",this._status)
			var src = this._status==0 ? this.options.src:this.options.tapSrc;
			this._img.Img("changeSrc",src);
		},
		setImage:function(src){
			this._img.Img("changeSrc",src);
		},
		changeImgSrc:function(src){ //切换图片
			
			if(this._status == 0){
				this._img.Img("changeSrc",src);
			}
		},
		
	});
})
