
define(['Shell','Btn','ImgBtn','Widget'],function(Shell, exports){
	$.widget("ys.NewHeader",$.ys.Widget,{ 
        options:{
            select:false,
            selects:false
        },
        _headerLeft:null,
        _headerTitle:null,
        _headerRight:null,
        // _select:null,
        _selects:null,
        _member:null,
        // _screens:null,
        __selectList:null,
        _isOof:true,
        _lock:true,
		//默认参数
		setBottomLine:function(){
			this.element.css({"border-bottom":"1px solid #EAEFF2"});
		},
		addSecTitle:function(text){
			if(this.element.find(".secTitle").length == 0){
				this.element.css("position","relative");
				this._headerTitle.attr("base-line-height",this._headerTitle.css("line-height"));
				this._headerTitle.animate({"line-height":"30px"});
				var secTitle = $("<div class='secTitle'>"+text+"</div>");
				secTitle.css({"font-size":"10px","color":"#999999","pointer-events":"none"});
				secTitle.css("position","absolute");
				secTitle.css("width","100%");
				secTitle.css("text-align","center");
				secTitle.css("bottom","4px");
				this._headerTitle.after(secTitle);
			}else{
				this.element.find(".secTitle").html(text);
			}
		},
		removeSecTitle:function(){
			if(this.element.find(".secTitle").length == 0){
				return;
			}
			this._headerTitle.animate({"line-height":this._headerTitle.attr("base-line-height")});
			this.element.find('.secTitle').remove();
		},
		//初始化，控件生命周期内只运行一次
		_init: function () {
            var that = this;
            this._super();
           
            if(typeof this.options.showSafeArea === 'undefined'){
                //次参数主要是兼容安卓，底部导航页面使用header组件时，此参数应该为true，ios默认为true
                this.options.showSafeArea = navigator.userAgent.toLowerCase().indexOf('android')>-1 ? false : true; 
            }
            var top = 0;
			this.element.css({"width":"100%","height":top+44+"px","background":"#fff","overflow":"hidden","z-index":20000});
			try{
				if(api.safeArea.top){
					this.element.css("height",api.safeArea.top+parseInt(this.element.css("height").replace("px",""))+"px");
					top += api.safeArea.top;
				}
			}catch(e){
            }
            if(this.options.bgColor != ""){
                this.element.css("background",this.options.bgColor); 
            }
            if(this.options.shadow === true){
                this.element.css({"boxShadow":"0px 6px 9px 2px rgba(0,37,87,0.06)"});
            }

            try{
                //设置电池条字体颜色
                if(global.skin_name != "dangjian" || global.skin_name != "redyingshuo"){
					//api.setStatusBarStyle({
					//	color:'#f0f'
					//});
                    //api.setStatusBarStyle(typeof this.options.statusBar === 'object' ? this.options.statusBar : {style : 'dark',color : '#ffffff'});//{style : 'dark',color : 'rgba(0,0,0,0.0)'});
                }
            }catch(e){
                console.warn(e)
            }
            if(this.options.leftTitle){
                this._headerLeft = $("<div></div>");
                this._headerLeft.css({"position":"absolute","top":top+"px","bottom":"0","left":"0","width":"6rem","padding-left":"1rem","height":"44px","line-height":"44px",
            "font-size":"0.9375rem","color":this.options.leftColor})
                this._headerLeft.html(this.options.leftTitle)
                this._headerLeft.Btn();
            }else{
                var leftImg = this.options.leftSrc?this.options.leftSrc:"../djcommon/img/icon_back@3x.png"
                this._headerLeft = $("<div></div>")
                if(this.options.backgroundSize != undefined){
                    this._headerLeft.css({"z-index":"2","position":"absolute","top":top+"px","bottom":"0","left":"0","width":"4rem","height":"44px","line-height":"44px","background":"url("+leftImg+")",
                    "backgroundSize":"0.1rem 0.17rem","backgroundPosition":"7% 50%","backgroundRepeat":"no-repeat"})
                }else{
                    this._headerLeft.css({"position":"absolute","top":top+"px","bottom":"0","left":"0","width":"4rem","height":"44px","line-height":"44px","background":"url("+leftImg+")",
                    "backgroundSize":"0.5625rem 0.9375rem","backgroundPosition":"25% 50%","backgroundRepeat":"no-repeat"})
                }
                
                this._headerLeft.Btn();
                
            }
            this.element.append( this._headerLeft);
           //1.8288rem
            this._headerTitle = $("<div></div>");
            if(this.options.backgroundSize != undefined){
                this._headerTitle.css({"position":"absolute","top":top+"px","bottom":"0","left":"0","width":"100%","height":"44px","line-height":"44px","color":"#333333",
                "textAlign":"center","fontWeight":"bold","whiteSpace":"nowrap","overflow":"hidden","textOverflow":"ellipsis"}).css({"fontSize":"17px"})
            }else{
                this._headerTitle.css({"position":"absolute","top":top+"px","bottom":"0","left":"6rem","width":"11.43rem","height":"44px","line-height":"44px","color":"#333333",
                "textAlign":"center","fontWeight":"bold","whiteSpace":"nowrap","overflow":"hidden","textOverflow":"ellipsis"}).css({"fontSize":"17px"})
            }
            if(this.options.textColor){
                this._headerTitle.css("color",this.options.textColor)
            }
            this._headerTitle.html(this.options.title);
            this.element.append(this._headerTitle); 

            var rightImg = this.options.rightSrcs?this.options.rightSrcs:"/assets/img/appimg/Cloud/tabbar_icon_add@3x.png"
            if(this.options.rightSrc){
                this._headerRight = $("<div id='rightIconBtn'></div>");
                this._headerRight.css({"position":"absolute","top":top+"px","bottom":"0","right":"0px","width":"3.125rem","line-height":"44px","height":"44px","background":"url("+rightImg+")",
                "backgroundSize":"1rem 1rem","backgroundPosition":"50% 50%","backgroundRepeat":"no-repeat"})
                this._headerRight.Btn();
                this.element.append( this._headerRight);
                this._headerRight.bind("BTN_CLICK",this,this.rightBtnClick);
            }
            if(this.options.rightTitle){
                this._headerRight = $("<div class='rightBtn'></div>");
                var cssRight = {"position":"absolute","top":top+"px","right":"0","width":"6rem","padding-right":"1rem","hieght":"44px","line-height":"44px","text-align":"right",
                "font-size":"0.9375rem","color":"#333333","font-weight":"bold"};
                if(this.options.rightColor){
                    cssRight.color = this.options.rightColor;
                }
                if(this.options.rightFontWeight){
                    cssRight.fontWeight = this.options.rightFontWeight;
                }
                this._headerRight.css(cssRight)
                this._headerRight.html(this.options.rightTitle)
                this._headerRight.Btn();
                this.element.append( this._headerRight);
                this._headerRight.bind("BTN_CLICK",this,this.rightBtnClick);
                
                if(this.options.rightWeight){
                    this._headerRight.css("font-weight",this.options.rightWeight);
                }
            }
            if(this.options.leftHide === true){
                this.setLeftHide();
            }
            if(this.options.rightEnable === false){
                this.setRightDisable();
            }
            if(this.options.select){
                this._selects = $("<div isOffs='1' class='select'></div>").appendTo(this.element);
                this._selects.css({
                    "z-index":"999",
                    "position":"absolute",
                    "top":top+"px",
                    "bottom":"0",
                    "right":"4.4rem",
                    "width":"3.125rem",
                    "height":"44px",
                    "background":"url('/assets/img/appimg/arrow_down@3x.png",
                    "backgroundSize":"1.125rem 1.25rem",
                    "backgroundPosition":"50% 50%",
                    "backgroundRepeat":"no-repeat",
                    "transition":"all 0.1s"
                });
                this._selects.bind("click",function(){
                    if($("#addFile").length == 1){
                        return;
                    }
                    if(that._lock){
                        that._lock = false;
                        if(parseInt($(this).attr("isOffs")) == 1){
                            $(this).attr("isOffs","2");
                            $(this).css("transform","rotate(180deg)");
                        }else{
                            $(this).attr("isOffs","1");
                            $(this).css("transform","rotate(0deg)");
                        }
                        that.element.trigger("SELRCT_UP_DOWS",parseInt($(this).attr("isOffs")));
                    }
                });
            }

            if(this.options.member == true){
                this._member = $("<div class='member'></div>").appendTo(this.element);
                this._member.css({
                    "z-index":"999",
                    "position":"absolute",
                    "top":top+"px",
                    "bottom":"0",
                    "right":"2.3rem",
                    "width":"3.125rem",
                    "height":"44px",
                    "background":"url('/assets/img/appimg/icon_zy@3x.png",
                    "backgroundSize":"1.125rem 1.25rem",
                    "backgroundPosition":"50% 50%",
                    "backgroundRepeat":"no-repeat",
                });
                this._member.bind("click",function(){
                that.element.trigger("MEMBER_LIST");
                });
            }

//            if(this.options.screen){
//             this._screens = $("<div></div>").appendTo(this.element);
//             this._screens.css({
//                 "z-index":"999",
//                 "position":"absolute",
//                 "top":top+"px",
//                 "bottom":"0",
//                 "left":"2rem",
//                 "width":"3.125rem",
//                 "height":"44px",
//                 "line-height": "44px",
//                 "font-size": "0.9375rem",
//                 "backgroundRepeat":"no-repeat",
//                 "font-weight": "bold"
//             });
//             $("<span>"+this.options.screen+"</span>").appendTo(this._screens);
//             }
//   
//             this._select = $("<div isOff='1' class='selects'></div>").appendTo(this._screens);
//                 this._select.css({
//                     "z-index":"999",
//                     "position":"absolute",
//                     "bottom":"0",
//                     "left":"1.3rem",
//                     "width":"2.125rem",
//                     "height":"44px",
//                     "background":"url('/assets/img/appimg/tabbar_icon_arrow@3x.png')",
//                     "backgroundSize":"0.5rem 0.5rem",
//                     "backgroundPosition":"50% 50%",
//                     "backgroundRepeat":"no-repeat",
//                     "transition":"all 0.1s"
//                 });
//                 this._select.bind("click",function(){
//                     if(that._lock){
//                         that._lock = false;
//                         if(parseInt($(this).attr("isOff")) == 1){
//                             $(this).attr("isOff","2");
//                             $(this).css("transform","rotate(180deg)");
//                         }else{
//                             $(this).attr("isOff","1");
//                             $(this).css("transform","rotate(0deg)");
//                         }
//                         that.element.trigger("SELRCT_UP_DOW",parseInt($(this).attr("isOff")));
//                         setTimeout(function(){
//                             that._lock = true;
//                         },300);
//                     }
//                 });

            this._headerLeft.bind("BTN_CLICK",this,this.backBtnClick);
        },
        setTitle:function(string){
            this._headerTitle.html(string);
        },
        setLeftTitle:function(string){
            this._headerLeft.html(string);
        },
        setLeftHide:function(){
            this._headerLeft.hide();
        },
        setLeftShow:function(){
            this._headerLeft.show();
        },
        setRightHide:function(){
            this._headerRight.hide();
        },
        setRightShow:function(){
            this._headerRight.show();
        },
        setRightDisable:function(){
            this._headerRight.Btn('setDisable');
        },
        setRightEnable:function(){
            this._headerRight.Btn('setEnable');
        },
        setRightColor:function(color){
            this._headerRight.css(color);
        },
        backBtnClick:function(e){
            e.data.element.trigger("BACK_CLICK");
        },
		rightBtnClick:function(e){
            e.data.element.trigger("RIGHT_CLICK");
        },
        lock:function(){
            this._lock = true;
        },
        //给页面js控制器提供一个修改head的方法
        changeHeadTitle:function(setNumm){
            this._headerTitle.html("已选中" + setNumm + "项");
        },
        changeHeadTitles:function(text){
            this._headerTitle.html(text);
        },
        // changeHeadAttr:function(text){
        //     // this._selects.attr("isOffs","1");
        //     // this._selects.css("transform","rotate(0deg)");
        //     this._select.attr("isOff","1");
        //     this._select.css("transform","rotate(0deg)");
        //     // this._screens.find("span").html(text);
        // },
        changeHeadAttrs:function(text){
            this._selects.attr("isOffs","1");
            this._selects.css("transform","rotate(0deg)");
 
        },
        //锁住返回按钮
        lockBack:function(type){
            if(type == undefined || type == null || type == "" || type == "yes"){
                this._headerLeft.css({"pointer-events":"none","opacity":"0.5"});
            }else{
                this._headerLeft.css({"pointer-events":"","opacity":""});
            }
        },
		//创建控件，控件生命周期内会运行多次
		_create: function () {},
		// 释放控件
		destroy: function () {
			$.Widget.prototype.destroy.call(this);
		}
	});
})