/*
 * 文字文本按钮 TextBtn 
 * 
*/
define(['Label','Btn'],function(require, exports){
    $.widget("ys.TextBtn",$.ys.Btn, { 
        //默认参数
        _label:null,
        _status:true,
        //初始化，控件生命周期内只运行一次
        _init: function () {
            this._super();  
		    if(this.options.text){
				this._label = $("<div></div>");  
				this.options.textColor = this.options.textColor?this.options.textColor:"#333";  
				this._label.Label({"text":this.options.text,"color":this.options.textColor,"fontSize":this.options.fontSize});
				this.element.append(this._label)  
			}
            //this.options.bgColor = this.options.bgColor?this.options.bgColor : "#FFF"; 
            this.options.textColor = this.options.textColor?this.options.textColor : "#333";
            this.changeBgColor(this.options.bgColor);  
		},
		_onMouseDown:function(e){ },    
        /**
		* 改变背景颜色
		*/
		changeBgColor:function(color){
			this.element.css("background",color);
		},
		/**
		* 改变文字颜色
		*/
		changeTextColor:function(color){    
			if(this._label){   
				this._label.BtnLabel("setColor",color);
			}
		},
        //创建控件，控件生命周期内会运行多次
        _create: function () {},
        // 释放控件
        destroy: function () {
            $.Widget.prototype.destroy.call(this);
        }
    });
})