/*
 * List title
 * 薛原
 * 
*/
define(['Label','Panel'],function(require, exports){
    $.widget("ys.TitleList",$.ys.Panel, { 
        //默认参数
        _label:null,
        //初始化，控件生命周期内只运行一次
        _init: function () {
            this._super();  
			this.element.css("position","relative");
			this.element.css("background","#ffffff");
		    if(this.options.title){
				var titleTextLabel =  $("<div></div>").Label({"text":this.options.title,"fontSize":"14px","color":"#000000","fontWeight":"800","lineHeight":this.options.height});
				titleTextLabel.Label("setLeft","30px");
				//titleTextLabel.Label("setTop","12px");
				titleTextLabel.css("position","absolute");
				this.element.append(titleTextLabel);
				
				var line = $("<div></div>").Panel({"width":"2px","height":parseInt(this.options.height.replace("px",""))/2+"px"});
				line.Panel("setBgColor","#C82128");
				line.Panel("setLeft","18px");
				line.Panel("setTop",this.options.height.replace("px","")/4+"px");
				line.css("position","absolute");
				this.element.append(line);
				if( typeof(this.options.style) != "undefined" && this.options.style == 1){
					line.remove();
					titleTextLabel.Label("setLeft","15px");
				}
			} 
		},
		_onMouseDown:function(e){
		},    
		_onMouseUp:function(e){
		},  
        /**
		* 改变背景颜色
		*/
		changeBgColor:function(color){
			this.element.css("background",color);
		},
		/**
		* 改变文字颜色
		*/
        //创建控件，控件生命周期内会运行多次
        _create: function () {},
        // 释放控件
        destroy: function () {
            $.Widget.prototype.destroy.call(this);
        }
    });
})