define(['jquery','Shell','Config'], function($,Shell,Config) {
    var adapter = Config.adapter;
    
    $.fn.style = function () {

        var css = arguments[0];

        switch (arguments.length) {
            case 1:{//只有1个参数时
                if(typeof css==="object"){//且该参数是一个对象
                    for(var x in css){//遍历css对象
                        var value = css[x];
                        if(typeof value === 'string'){
                            css[x] = adapter.autoTrans(value);
                        }
                    }
                    this.css(css);
                    value = void 0;
                }
                break;
            }
            case 2:{//只有2个参数时，此时是css 键值对
                var value = arguments[1];
                if(typeof value === 'string'){
                    value = adapter.autoTrans(value);
                }
                this.css(css,value);
                value = void 0;
                break;
            }
        }
        css = void 0;
        return this;
    };
    $.transPx = function (px) {
        var num;
        switch (typeof px) {
            case 'string':
                num = parseFloat(px.replace('px',''));
                if(isNaN(num)){
                    throw Error('错误的值:'+px)
                }
                break;
            case 'number':
                num = px;
                break;
        
            default:
                break;
        }
        return Config.adapter.getDevPx(num)
    };
    $.fn.reacYBottom = function (px) {
        return this[0].getBoundingClientRect().bottom+(px ? "px" : 0);
    };
    $.fn.reacYTop = function (px) {
        return this[0].getBoundingClientRect().top+(px ? "px" : 0);
    };
    $.fn.reacXLeft = function (px) {
        return this[0].getBoundingClientRect().left+(px ? "px" : 0);
    };
    $.fn.reacXRight = function (px) {
        return this[0].getBoundingClientRect().right+(px ? "px" : 0);
    };
    $.fn.reacHeight = function (px) {
        return this[0].getBoundingClientRect().height+(px ? "px" : 0);
    };
    $.fn.reacWidth = function (px) {
        return this[0].getBoundingClientRect().width+(px ? "px" : 0);
    };
    $.fn.reacX = function (px) {
        return this[0].getBoundingClientRect().x+(px ? "px" : 0);
    };
    $.fn.reacY = function (px) {
        return this[0].getBoundingClientRect().y+(px ? "px" : 0);
    };
});