/*
*   2020年12月2日
*
*   笔记首页的js控制器
*
*   开发者：薛原
*/
define(['base64',"jquery","Shell","Fastclick","Config","NoteBookDataModel","TokenDataModel","NotePenDataModel","PenStatusPanel","LinkPenPanel","ImgBtn","BookSlider","DownMenu"], function (Base64,$,Shell,Fastclick,Config,NoteBookDataModel,TokenDataModel,NotePenDataModel) {
	var chooseDownMenu;
	var penStatusPanel;
	var linkPenPanel;
	var bookSlider;
	var localPenData; //离线笔数据
	var autoLinkSgin = false;
	var interWinLock = false;
	var tid;
    var Controller = {
        init:function(){
			try{
				api.setPrefs({
					key: 'token',
					value: ''
				});
			}catch(e){}
			$("body").css("background","url(../djcommon/img/note/main_bg.png)");
			$("body").css("width",$(window).width()+"px");
			$("body").css("height",$(window).height()-50+"px");
			$("body").css("background-size","100% 100%"); 
			$("body").css("background-attachmen","fixed"); 
			$("body").css("overflow","hidden");
			try{
				NotePenDataModel.setLinked(0); //进入重置
			}catch(e){
			}
            Controller.create();//调用生成页面方法
			Config.adapter.setBaseRem();
			//通知原生关闭加载动画
			setTimeout(function(){
				Shell.sendPageReady();
				Controller.addEventListener();//侦听壳事件			
				Controller.sendEvent();//抛出事件
			},100);
			
			//每十秒钟获取一次设备电量
			setInterval(function(){
				Controller.getPenDetail();
			},10000);
			/*
			setTimeout(function(){
				var t = 0;
				setInterval(function(){
					t++;
					if(t <= 100){
				    	Shell.sendEvent("YsPenUnlineDataSynProgressChange",{"progress":t});
					}
				},200);
				
			},10000);*/
			
        },
		//获取笔详情，包括电量
		getPenDetail:function(){
			if(NotePenDataModel.getLinked()){
				var penData = NotePenDataModel.getLocationLinkedPenWithNoEvent();
				if(penData != null && typeof(penData) != "undefined" && typeof(penData.mac) != "undefined" && typeof(penData.vid) == "undefined"){
					Shell.sendEvent("getYsPenDetailData",{"mac":penData.mac});
				}
			}
		},
        //生成页面方法
        create:function(){
			var btnPanel = $("<div></div>").Panel({"height":"40px","width":"345px","marginTop":"30px","marginBottom":"10px"});
			var penManagerEnterBtn = $("<div></div>").ImgBtn({"width":"37px","height":"37px","src":"../djcommon/img/note/note-pen-manager.png","marginRight":"15px"});
			penManagerEnterBtn.bind("BTN_CLICK",function(e){
				try{
					Shell.sendEvent("CallWriteTimeLineModule");
				}catch(e){}
			});
			var moreEnterBtn = $("<div></div>").ImgBtn({"width":"37px","height":"37px","src":"../djcommon/img/note/note-more.png"});
			moreEnterBtn.attr("data-status","hide");
			moreEnterBtn.find("img").addClass("note-more");
			moreEnterBtn.bind("BTN_CLICK",function(){
				var currPen = NotePenDataModel.getLocationLinkedPenWithNoEvent();
				var linked = NotePenDataModel.getLinked();
				if(linked == 1 && typeof(currPen.vid) != "undefined"){
						api.addEventListener({"name":"ActionMenuOptionClick"},function(e){
						api.removeEventListener({"name":"ActionMenuOptionClick"});
						if(e.value.actionId == 0){ 
							Shell.sendEvent("openWin",{"url":"/notebookmanage/noteBookManage.html","open_type":true,"title":"智能本管理"});
						}
					});
					Shell.sendEvent("ShowActionMenu",{
						"menuType":0,
						"btn":[
							{"actionId":0,"name":"本子管理"},
							{"actionId":1,"name":"取消"}
						]
					});   
				}else{
						api.addEventListener({"name":"ActionMenuOptionClick"},function(e){
						api.removeEventListener({"name":"ActionMenuOptionClick"});
						if(e.value.actionId == 0){ 
							Shell.sendEvent("openWin",{"url":"/notepenmanage/notePenManage.html","open_type":true,"title":"智能笔管理"});
						}else if(e.value.actionId == 1){
							Shell.sendEvent("openWin",{"url":"/notebookmanage/noteBookManage.html","open_type":true,"title":"智能本管理"});
						}
					});
					Shell.sendEvent("ShowActionMenu",{
						"menuType":0,
						"btn":[
							{"actionId":0,"name":"连接管理"},
							{"actionId":1,"name":"本子管理"},
							{"actionId":2,"name":"取消"}
						]
					});   
				}
			});
			penManagerEnterBtn.css("float","right");
			moreEnterBtn.css("float","right");
			btnPanel.Panel("addElement",moreEnterBtn);
			btnPanel.Panel("addElement",penManagerEnterBtn); //书写时光轴按钮屏蔽
			
			penStatusPanel = $("<div></div>").PenStatusPanel();
			
			
			//有线笔连接按钮被点击
			penStatusPanel.bind("LINE_BTN_CLICK",function(){
				try{
					api.addEventListener({"name":"LinkYsPenGetLocalUSBStatus"},function(e){
					    api.removeEventListener({"name":"LinkYsPenGetLocalUSBStatus"});
						if(e.value.status == 0){ //USB授权不正确,提示用户授权
							try{
								api.addEventListener({"name":"AlertHasBeedClick"},function(e){
									api.removeEventListener({"name":"AlertHasBeedClick"});
								});
								Shell.sendEvent("ShowMeTheAlert",{"title":"USB权限未开放","btn":["确认"]});
							}catch(e){
								//alert(e);
							}
						}else{
							linkPenPanel.css("top","-1000px");
							linkPenPanel.show();
							linkPenPanel.LinkPenPanel("show");
							linkPenPanel.LinkPenPanel("setSearchingStatusWithNoEvent");
							
							api.addEventListener({"name":"FoundHasLineYsPen"},function(e){
								clearTimeout(tid);
								try{
									api.removeEventListener({"name":"FoundHasLineYsPen"});
									linkPenPanel.LinkPenPanel("setFoundHasPenStatus",e.value);
								}catch(e){
									alert(e);
								}
							});
							
							Shell.sendEvent("beginScanUSBYsPen"); //开始扫描有线笔
							
							tid = setTimeout(function(){
								api.removeEventListener({"name":"FoundHasLineYsPen"});
								clearTimeout(tid);
								linkPenPanel.LinkPenPanel("cancelScanLink");
								api.addEventListener({"name":"AlertHasBeedClick"},function(e){
									api.removeEventListener({"name":"AlertHasBeedClick"});
								});
								Shell.sendEvent("ShowMeTheAlert",{"title":"未检测到有线笔","contents":"可能原因如下：\r\n1、有线笔未连接手机，请连接后重试；\r\n2、手机的OTG功能未开启，请到系统设置中开启后重试；\t\n3、检测有线笔设备是否损坏；","btn":["我知道了"]});
							},5000);
						}
					});
					//向原生壳询问USB权限
					Shell.sendEvent("getLinkYsPenGetLocalUSBStatus");
					setTimeout(function(){
					    //Shell.sendEvent("LinkYsPenGetLocalUSBStatus",{"stauts":1}); //开始扫描有线笔
					},1000);
					
				}catch(e){
				}
			});
			//蓝牙笔连接按钮被点击
			penStatusPanel.bind("LINK_BTN_CLICK",function(){
				try{
					Shell.sendEvent("lockTabBar",{"lock":true});
					api.addEventListener({"name":"LinkYsPenGetLocalBluetoothAndPositionStatus"},function(e){
					    api.removeEventListener({"name":"LinkYsPenGetLocalBluetoothAndPositionStatus"});
						if(e.value.status == 0){ //授权不正确,提示用户授权
							linkPenPanel.css("top","-1000px");
							linkPenPanel.show();
							linkPenPanel.LinkPenPanel("show");
							linkPenPanel.LinkPenPanel("setPowerFailStatus");
						}else{ //授权成功
						    linkPenPanel.css("top","-1000px");
							linkPenPanel.show();
							linkPenPanel.LinkPenPanel("show");
							var prefs = api.getPrefs({
								sync: true,
								key: 'linkedHistory'
							});
							if(prefs && prefs.split("|").length > 0){
								linkPenPanel.LinkPenPanel("setSearchingStatus",prefs);
							}else{
						    	linkPenPanel.LinkPenPanel("setSearchingStatus");
							}
						}
					});
					//向原生壳询问定位和蓝牙权限
					Shell.sendEvent("getLinkYsPenGetLocalBluetoothAndPositionStatus");
				}catch(e){
				}
			});
			penStatusPanel.bind("DETAIL_BTN_CLICK",function(){
				Shell.sendEvent("openWin",{"url":"/notependetail/notePenDetail.html","open_type":true,"title":"设备信息"});
			});
		
			
			linkPenPanel = $("<div></div>").LinkPenPanel();
			//有线笔连接
			linkPenPanel.bind("LINK_HAS_LINE_PEN",function(){
				//向原生壳发起有线笔连接事件
				try{
					Shell.sendEvent("startLinkHasLineYsPen");
				}catch(e){}
			});
			//重新搜索按钮被点击
			linkPenPanel.bind("LINK_PEN_HIDE",function(){
				try{
			    	Shell.sendEvent("hideTabBar",{"hide":false});
				}catch(e){}
			});
			window.xueyuan =  linkPenPanel;
			linkPenPanel.hide();
			
			
			//重新获取授权
			linkPenPanel.bind("RE_POWER",function(){
				try{
					api.addEventListener({"name":"LinkYsPenGetLocalBluetoothAndPositionStatus"},function(e){
					    api.removeEventListener({"name":"LinkYsPenGetLocalBluetoothAndPositionStatus"});
						if(e.value.status == 0){ //授权不正确,提示用户授权
							
						}else{ //授权成功
						    linkPenPanel.css("top","-1000px");
							linkPenPanel.show();
							linkPenPanel.LinkPenPanel("show");
							var prefs = api.getPrefs({
								sync: true,
								key: 'linkedHistory'
							});
							if(prefs && prefs.split("|").length > 0){
								linkPenPanel.LinkPenPanel("setSearchingStatus",prefs);
							}else{
								linkPenPanel.LinkPenPanel("setSearchingStatus");
							}
						}
					});
					//向原生壳询问定位和蓝牙权限
					Shell.sendEvent("getLinkYsPenGetLocalBluetoothAndPositionStatus");
				}catch(e){
				}
			});
			
			//发送笔开始检测消息
			linkPenPanel.bind("SCAN_YS_PEN_BEGEN",function(){
				try{
					api.addEventListener({"name":"foundYsPenList"},function(e){
						e.value.data = JSON.parse(e.value.data);
						linkPenPanel.LinkPenPanel("setSearchResultStatus",e.value.data);
						if(e.value.data.length > 0){
							Shell.sendEvent("hideTabBar",{"hide":true});
						}
					});
					//向原生壳询问附近设备
					Shell.sendEvent("startScanYsPen");
				}catch(e){
				}
			});
			//监听搜索倒计时结束事件
			linkPenPanel.bind("SCAN_YS_PEN_END",function(){
				clearTimeout(tid);
				try{
					api.removeEventListener({"name":"foundYsPenList"});
				}catch(e){
				}
			});
			//发送笔检测消息
			linkPenPanel.bind("SCAN_YS_PEN_CHECK",function(){
				try{
					//向原生壳询问附近设备
					Shell.sendEvent("startScanYsPen");
				}catch(e){
				}
			});
			//发送笔检测消息  
			linkPenPanel.bind("SCAN_YS_PEN_GET_RESULT",function(){
				try{
					//向原生壳询问附近设备
				    Shell.sendEvent("getScanYsPenResult");
				}catch(e){
				}
			});
			//开始连接笔
			linkPenPanel.bind("START_LINK",function(e,data){
				try{
				    Shell.sendEvent("startLinkYsPen",{"mac":data.mac,"linked":"0","penType":typeof(data.penType) != "undefined" ? data.penType : 4});
				}catch(e){
				}
			});
			$("body").append(linkPenPanel);
			linkPenPanel.css("position","absolute");
			linkPenPanel.css("z-index",1000);
			$("body").append(btnPanel);
			$("body").append(penStatusPanel);
			//解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
		},
		addEventListener:function(){
			//侦听笔记服务准备就绪
			try{
				api.addEventListener({"name":"NoteServerReady"},function(e){
					/*api.toast({
						msg: "刚哥服务准备就绪",
						duration: 1000,
						location: 'middle'
					});*/
				});
			}catch(e){}
			try{
				//监听连接成功事件 
				api.addEventListener({"name":"linkSecc"},function(e){
					penStatusPanel.PenStatusPanel("changeMainLabelText",e.value.name);
				});
			}catch(e){}
			//侦听底部导航切换事件
			try{
				api.addEventListener({"name":"NavHasBeenChanged"},function(e){
					try{
						linkPenPanel.LinkPenPanel("cancelScanLinkAtOnce");
						linkPenPanel.hide();
					}catch(e){}
				});
			}catch(e){}
			//获取笔离线数据同步事件
			try{
				api.addEventListener({"name":"YsPenUnlineDataSynProgressChange"},function(e){
					//alert("笔同步离线数据进度："+JSON.stringify(e));
					/*api.toast({
						msg: JSON.stringify(e),
						duration: 1000,
						location: 'middle'
					});*/
					localPenData = NotePenDataModel.getLocationLinkedPenWithNoEvent();
					if(localPenData && NotePenDataModel.getLinked() == 1){
						if(e.value.progress == 100){ //作为同步完成标识
						    //Shell.sendEvent("CloseSilenceLockScreen");
							try{
							    penStatusPanel.PenStatusPanel("changeLinkStatus",1);
								localPenData = NotePenDataModel.getLocationLinkedPenWithNoEvent();
							    penStatusPanel.PenStatusPanel("changeMainLabelText",localPenData.name);
							}catch(e){
							}
						}else{
							//Shell.sendEvent("OpenSilenceLockScreen");
							try{
							    penStatusPanel.PenStatusPanel("changeLinkStatus",2);
							    penStatusPanel.PenStatusPanel("changeMainLabelText","正在同步离线数据："+e.value.progress+"%");
							}catch(e){
							}
						}
					}
				});
			}catch(e){}
			//重命名笔名字成功事件
			try{
				api.addEventListener({"name":"RenameNotePenSuccess"},function(e){
					//alert("笔改名成功："+JSON.stringify(e));
					if(localPenData){
						localPenData.name = e.value.name;
					}
					var obj = NotePenDataModel.getLocationLinkedPenWithNoEvent();
					if(obj && obj.name){
					    obj.name = e.value.name;
						obj.penType = typeof(e.value.penType) != "undefined" ? e.value.penType : "4";
					    NotePenDataModel.setLocationLinkedPen(obj);
					}
					if(penStatusPanel){
						penStatusPanel.PenStatusPanel("changeMainLabelText",obj.name);
					}
				});
			}catch(e){}
			//设备电量获取侦听
			try{
				api.addEventListener({"name":"getYsPenDetailDataReady"},function(e){
					//alert(JSON.stringify(e));
					if(penStatusPanel){
						penStatusPanel.PenStatusPanel("changePowerVal",e.value.power+"%");
					}
				});
			}catch(e){}
			
			//取得离线笔数据
			$(window).bind("GET_NOTE_LINKED_PEN_DATA_SUCCESS",function(e,data){   
				localPenData = data;
				//alert(JSON.stringify(data));
				 if(data && data.autoLink == 1){   //有离线数据 并且 设置了自动连接
					 //尝试连接
					 try{
						var obj = {"mac":data.mac,"linked":"1","penType":typeof(data.penType) != "undefined" ? data.penType : 4,"linkType":"auto","autoEventTimes":1};
						if(typeof(data.penName) != "undefined"){
							obj.penName = data.penName;
						}
						Shell.sendEvent("startLinkYsPen",obj); //1为之前连过的直连
						// setTimeout(function(){
						// 	var obj = {"mac":data.mac,"linked":"1","penType":typeof(data.penType) != "undefined" ? data.penType : 4,"linkType":"auto","autoEventTimes":2};
						//     if(typeof(data.penName) != "undefined"){
						// 	    obj.penName = data.penName;
						//     }
					    //     Shell.sendEvent("startLinkYsPen",obj); //1为之前连过的直连
						// },1000);
					}catch(e){
					}
				 }else{
					 penStatusPanel.PenStatusPanel("changeLinkStatus",0);
				 }
			});
			try{
				//建立全局侦听 连接笔成功时处理
				api.addEventListener({"name":"LinkYsPenSuccess"},function(e){
					if(e.value.VID){ //有线笔
						NotePenDataModel.setLocationLinkedPen({"mac":"","vid":e.value.VID,"pid":e.value.PID,"name":"奕章有线笔","autoLink":0,"penName":typeof(e.value.penName) != "undefined"?e.value.penName:"","penType":typeof(e.value.penType) != "undefined" ? e.value.penType : "4"});
						clearTimeout(tid);
						linkPenPanel.LinkPenPanel("cancelScanLink");
						penStatusPanel.PenStatusPanel("changeLinkStatus",1);
						penStatusPanel.PenStatusPanel("changeMainLabelText","奕章有线笔");
						penStatusPanel.PenStatusPanel("hidePowerArea");
						NotePenDataModel.setLinked(1);
					}else{
						try{
							//偏好设置
							var date = new Date();
							api.setPrefs({
								key: 'linkedHistory',
								value: e.value.mac+"|"+date.getTime()
							});
							api.setPrefs({
								key: 'isSelfBind',
								value: e.value.isSelfBind
							});
							penStatusPanel.PenStatusPanel("changeMainLabelText","蓝牙笔");
							localPenData = NotePenDataModel.getLocationLinkedPenWithNoEvent();
							if(localPenData != null &&  typeof(localPenData) != "undefined" && localPenData.mac == e.value.mac && localPenData.autoLink == 1){
								NotePenDataModel.setLocationLinkedPen({"mac":e.value.mac,"name":"蓝牙笔","autoLink":1,"penName":typeof(e.value.penName) != "undefined"?e.value.penName:"","penType":typeof(e.value.penType) != "undefined" ? e.value.penType : "4"});
							}else{
								NotePenDataModel.setLocationLinkedPen({"mac":e.value.mac,"name":"蓝牙笔","autoLink":0,"penName":typeof(e.value.penName) != "undefined"?e.value.penName:"","penType":typeof(e.value.penType) != "undefined" ? e.value.penType : "4"});
							}
							//联网获取连接的笔的名字
							$(window).unbind("GET_PEN_NAME_SUCCESS").bind("GET_PEN_NAME_SUCCESS",function(e,data){
								if(typeof(data) != "undefined" && typeof(data.data) != "undefined" && data.data != ""){
									var obj = NotePenDataModel.getLocationLinkedPenWithNoEvent();
									obj.name = data.data;
									NotePenDataModel.setLocationLinkedPen(obj);
									penStatusPanel.PenStatusPanel("changeMainLabelText",obj.name);
								}
							});
							NotePenDataModel.getPenName(e.value.mac);
							clearTimeout(tid);
							linkPenPanel.LinkPenPanel("cancelScanLink");
							penStatusPanel.PenStatusPanel("showPowerArea");
							penStatusPanel.PenStatusPanel("changeLinkStatus",1);
							NotePenDataModel.setLinked(1);
						}catch(e){
							alert("1"+e);
						}
					}
				});
				//建立全局侦听 丢失连接时处理
				api.addEventListener({"name":"loseLinkYsPen"},function(e){
					clearTimeout(tid);
					penStatusPanel.PenStatusPanel("showPowerArea");

					linkPenPanel.LinkPenPanel("cancelScanLink");
					penStatusPanel.PenStatusPanel("changeLinkStatus",0);
					NotePenDataModel.setLinked(0);
				});
			}catch(e){}
			
			try{
				//重命名成功事件
				api.addEventListener({"name":"RenameNoteBookSuccess"},function(e){
					if(bookSlider){
						try{
							bookSlider.BookSlider("changeBookName",{"name":e.value.name,"uuid":e.value.uuid});
						}catch(e){
						}
					}
				});
			}catch(e){
			}
			
			$(window).bind("GET_NOTE_BOOK_DATA_ERROR",function(){
				var errorPanel = $("<div></div>").Panel({"width":"100%","height":"80px"});
		        var errorText = $("<div></div>").Label({"text":"智能笔服务故障","fontSize":"18px","fontWeight":"800","letterSpacing":"2px","width":"100%","textAlign":"center"});
				errorText.css("position","absolute");
				errorText.css("opacity","0");
				errorText.animate({"opacity":0.7},500,function(){
				    reloadBtn.show();
					reloadBtn.animate({"opacity":0.7},500);
				});
				errorText.Label("setTop","0px");
				errorPanel.append(errorText);
				var reloadBtn = $("<div class='linkBtn'></div>").BaseBtn({"text":"重试","width":"100px","height":"30px","fontSize":"14px","textColor":"#CF000F"});
				reloadBtn.css("border-radius","3rem");
				reloadBtn.css("border","1px solid #CF000F");
				reloadBtn.css("position","absolute");
				reloadBtn.BaseBtn("setLeft","137.5px");
				reloadBtn.BaseBtn("setTop","40px");
				reloadBtn.css("opacity",0);
				reloadBtn.hide();
				errorPanel.append(reloadBtn);
				$("body").append(errorPanel);
				errorPanel.css("margin-top",($(window).height()-penStatusPanel.offset().top-penStatusPanel.height()-errorPanel.height())/2+"px");
				reloadBtn.bind("BTN_CLICK",function(){
					errorPanel.remove();
					NoteBookDataModel.getData();
				});
			});
			$(window).bind("GET_NOTE_BOOK_DATA_SUCCESS",function(e,data){
				if(bookSlider){
					bookSlider.remove();
					bookSlider = null;
				}
			    var bookData = [];
				for(var i=0;i<data.data.length;i++){
					var one = {};
					one.uuid = data.data[i].id;
					one.name = data.data[i].bookName;
					one.bookType = data.data[i].bookType;
					one.type = one.bookType;
					one.status = data.data[i].activeFlag=="1"?"已启用":"已锁定";
					bookData.push(one);
				}
				bookData.push({"type":"0","name":"新建智能本"});
		        bookSlider = $("<div></div>").BookSlider({
				    "bookData":bookData
				});
				bookSlider.bind("CREATE_BOOK_BTN_CLICK",function(){
					if(interWinLock){
						return;
					}
					interWinLock = true;
					setTimeout(function(){
					    interWinLock = false;
					},3000);
					Shell.sendEvent("openWin",{"url":"/notecreate/noteCreate.html","open_type":true,"title":"新建智能本"});
				});
				bookSlider.bind("ENTER_BOOK_BTN_CLICK",function(e,data){
					Shell.sendEvent("InterBook",{"bookId":data.bookId,"bookType":data.bookType});
				});
				$("body").append(bookSlider);
				bookSlider.BookSlider("init");
			});
			try{
				//监听书写页面点击返回回到首页
				api.addEventListener({"name":"NOTE_BOOK_DATA_CHANGE"},function(e){
					if(e.value.bookId != undefined && e.value.bookId != null && e.value.bookId != ""){
						bookSlider.BookSlider("changeSildePosition",e.value.bookId);
					}else{
						NoteBookDataModel.getData();
					}
				});
			}catch(e){
			}
		},
		sendEvent:function(){
			if(typeof(api) == "undefined"){
				TokenDataModel.ACCOUNT_CODE = "3845536128749059108";
				NoteBookDataModel.getData();
			}else{
				try{
					var userData = Base64.decode(window.location.href.split("userInfo=")[1]);
					userData = JSON.parse(userData);
					TokenDataModel.ACCOUNT_CODE = userData.username;
					//alert(userData.urls.note_server_domain);
					if(typeof(userData.urls.note_server_domain) != "undefined"){
						TokenDataModel.setDomain(userData.urls.note_server_domain);
					}else{
						TokenDataModel.setDomain("https://testsmartpen.ys100edu.com");
					}
					var saveAccountCode = localStorage.getItem("accountCode");
					if(saveAccountCode){
						if(saveAccountCode != TokenDataModel.ACCOUNT_CODE){ //判断到账号进行了切换
							//清空偏好
							api.setPrefs({
								key: 'linkedHistory',
								value: ""
							});
							//清理离线缓存
							NoteBookDataModel.clearCacheData();
							NotePenDataModel.clearCacheData();
						}
					}
					localStorage.setItem("accountCode",TokenDataModel.ACCOUNT_CODE);
					NoteBookDataModel.getData();
				}catch(e){
					alert(e);
				}
			}
			NotePenDataModel.getLocationLinkedPen();
		}
    }
    
    return Controller;
});
