/*
*   2020年12月3日
*
*   笔记-智能笔管理的js控制器
*
*   开发者：薛原
*/
define(["jquery","Shell","Fastclick","Config",'iscroll',"NotePenDataModel","TokenDataModel","NewHeader","Panel","Label","BaseBtn",'PenCell',"TitleList","Img"], function ($,Shell,Fastclick,Config,IScroll,NotePenDataModel,TokenDataModel) {
	var scrollPanel;
	var penTitlePanel;
	var mainText;
	var secText;
	var bindPenData = [];
	var foundPenData = [];
	var scanBtn;
	var detailBtn;
	var myScroll;
	var linked; //是不是连接中
	var dealMac;
	var linkingPenData;
	var noLinkSecTitle = "请确认蓝牙笔笔身的MAC或SN码段";
	var toastStatus = false;
	
	var  gotoLink = false;
	var linkTimer = 0;
	var ul;
	var delSign = true;
	var first = true;
    var Controller = {
        init:function(){
            Controller.create();//调用生成页面方法
			Config.adapter.setBaseRem();
			Controller.addEventListener();
			//通知原生关闭加载动画
			setTimeout(function(){
				Shell.sendPageReady();
			},100);
        },
        //生成页面方法
        create:function(){
			var header = $("<div></div>").NewHeader({"title":" "});
			header.bind("BACK_CLICK",function(){
				//关闭窗口
				Shell.sendEvent("closeWin");
			});
			$("body").append(header);
			penTitlePanel = $("<div></div>").Panel({"width":"100%","height":"200px"});
			var penImg = $("<div></div>").Img({"src":"../djcommon/img/note/mac.png","width":"90px","height":"90px"});
			penImg.css("position","absolute");
			penImg.Img("setLeft","15px");
			penImg.Img("setTop","20px");
			penTitlePanel.Panel("addElement",penImg); 
			
			mainText = $("<div class='mainText'></div>").Label({"text":"蓝牙笔","fontSize":"20px","fontWeight":"800","letterSpacing":"2px"});
			mainText.css("opacity",0);
			mainText.animate({"opacity":1},500,function(){
				secText.animate({"opacity":1},500,function(){
				});
				scanBtn.animate({"opacity":0.5},500,function(){
			        NotePenDataModel.getData(); //获取在线笔数据
				});
			});
			mainText.css("position","absolute");
			mainText.Label("setLeft","120px");
			mainText.Label("setTop","15px");
			penTitlePanel.Panel("addElement",mainText);
			
			secText = $("<div class='secText'></div>").Label({"text":noLinkSecTitle,"fontSize":"14px","color":"#666666"});
			secText.css("opacity",0);
			secText.css("position","absolute");
			secText.Label("setLeft","120px");
			secText.Label("setTop","50px");
			penTitlePanel.Panel("addElement",secText);
			
			scanBtn = $("<div class='linkBtn'></div>").BaseBtn({"text":"检索中","width":"74px","height":"32px","fontSize":"12px","textColor":"#CF000F","noNeedAutoUnlock":true});
			scanBtn.css("opacity",0);
			scanBtn.BaseBtn("setDisable");
			scanBtn.css("border-radius","3rem");
			scanBtn.css("border","1px solid #CF000F");
			scanBtn.css("position","absolute");
			scanBtn.BaseBtn("setLeft","120px");
			scanBtn.BaseBtn("setTop","78px");
			penTitlePanel.Panel("addElement",scanBtn);
			
			detailBtn = $("<div class='linkBtn'></div>").BaseBtn({"text":"设备详情","width":"74px","height":"32px","fontSize":"12px","textColor":"#999999"});
			detailBtn.BaseBtn("setDisable");
			detailBtn.bind("BTN_CLICK",function(){
				Shell.sendEvent("openWin",{"url":"/notependetail/notePenDetail.html","open_type":true,"title":"设备信息"});
			});
			detailBtn.css("opacity",0);
			detailBtn.css("border-radius","3rem");
			detailBtn.css("border","1px solid #999999");
			detailBtn.css("position","absolute");
			detailBtn.BaseBtn("setLeft","210px");
			detailBtn.BaseBtn("setTop","78px");
			penTitlePanel.Panel("addElement",detailBtn);			
			detailBtn.hide();
			scanBtn.css("opacity",0);
			
			scanBtn.bind("BTN_CLICK",function(e){
				if(linkTimer){
					clearTimeout(linkTimer);
					delSign = true;
					linkTimer = 0;
				}
				gotoLink = false;
		        penTitlePanel.css("border-bottom","0px");
				$(".pen-cell").each(function(){
					$(this).PenCell("setBtnDisable");
				});
				setTimeout(function(){
					detailBtn.hide();
					scanBtn.BaseBtn("changeText","检索中");
					scanBtn.BaseBtn("setDisable");
					$(".newTitle").remove();
					$(".nobindPen").remove();
					Controller.findLocationPen();
				},200);
			});
			
			$("body").append(penTitlePanel);
			//解决移动端点击事件300ms延迟问题
            Fastclick.attach(document.body);
		},
		//解除绑定
		onDeleteBtnClick:function(e,data){
			if(delSign == false){
				return;
			}
			var mac = data.mac;
			dealMac = data.mac;
			try{
				api.addEventListener({"name":"AlertHasBeedClick"},function(e){
					api.removeEventListener({"name":"AlertHasBeedClick"});
					if(e.value.index == 1){
						NotePenDataModel.unbind(mac,data.snAddr);
					}else{
						if( $('.pen-cell').length > 0){
							$('.pen-cell').each(function(){
								$(this).PenCell("cancelDeleteMode");
							});
						}
					}
				});
				Shell.sendEvent("ShowMeTheAlert",{"title":"删除后下次连接需重新输入连接密码，确认删除吗？","btn":["取消","确认"]});
			}catch(e){}
		},
		cellBtnClick:function(e,data){
			detailBtn.BaseBtn("setDisable");
			$(".pen-cell").each(function(){
				$(this).PenCell("setBtnDisable");
			});
			scanBtn.BaseBtn("setDisable");
			if(typeof(data.style) != "undefined" && data.style == "red"){
				var u = navigator.userAgent;
				if(u.indexOf('Android') > -1 || u.indexOf('Linux') > -1){
					Shell.sendEvent("cancelLinkYsPen",{"mac":data.mac});
				}else{
					if(parseInt(data.penType) == 4){
						Shell.sendEvent("cancelLinkYsPen",{"mac":data.snAddr});
					}else{
						Shell.sendEvent("cancelLinkYsPen",{"mac":data.mac});
					}
				}
			}else{
				if(linked == 1){
					try{
						api.addEventListener({"name":"AlertHasBeedClick"},function(e){
							api.removeEventListener({"name":"AlertHasBeedClick"});
							$(".pen-cell").each(function(){
								$(this).PenCell("setBtnEnable");
							});
							detailBtn.BaseBtn("setEnable");
						});
						Shell.sendEvent("ShowMeTheAlert",{"title":"您已连接蓝牙笔，请断开后再连接","btn":["确认"]});
					}catch(e){

					}
				}else{
					$(this).PenCell("setBtnText","连接中");
					setTimeout(function(){
						linkingPenData = data;
						api.addEventListener({"name":"LinkYsPenGetLocalBluetoothAndPositionStatus"},function(e){
					   		api.removeEventListener({"name":"LinkYsPenGetLocalBluetoothAndPositionStatus"});
							if(e.value.status == 0){ //授权不正确,提示用户授权
								try{
									api.addEventListener({"name":"AlertHasBeedClick"},function(e){
										api.removeEventListener({"name":"AlertHasBeedClick"});
										$(".pen-cell").each(function(){
											$(this).PenCell("setBtnEnable");
											$(this).PenCell("setBtnText","连接");
										});
									});
									Shell.sendEvent("ShowMeTheAlert",{"title":"请先开启蓝牙及位置服务功能","btn":["确认"]});
								}catch(e){}
							}else{
								Controller.addLoseLinkEvent();
								var u = navigator.userAgent;
								if(u.indexOf('Android') > -1 || u.indexOf('Linux') > -1){
									Shell.sendEvent("startLinkYsPen",{"mac":data.mac,"linked":"0","penType":typeof(data.penType) != "undefined" ? data.penType : 4});
								}else{
									if(parseInt(data.penType) == 4){
										Shell.sendEvent("startLinkYsPen",{"mac":data.snAddr,"linked":"0","penType":typeof(data.penType) != "undefined" ? data.penType : 4});
									}else{
										Shell.sendEvent("startLinkYsPen",{"mac":data.mac,"linked":"0","penType":typeof(data.penType) != "undefined" ? data.penType : 4});
									}
								}
							}
						});
						//向原生壳询问定位和蓝牙权限
						Shell.sendEvent("getLinkYsPenGetLocalBluetoothAndPositionStatus");
					},1000);
				}
			}
		},
		addEventListener:function(){
			var that = this; 
			
			try{
				//监听重命名成功
				api.addEventListener({"name":"RenameNotePenSuccess"},function(e){
					try{
						// scanBtn.trigger("BTN_CLICK");
						NotePenDataModel.getData();
						setTimeout(function(){
							detailBtn.BaseBtn("setEnable");
						},1000);
					}catch(e){}
				});
				//监听蓝牙断开
				api.addEventListener({"name":"bluetoothOff"},function(e){
					try{
						secText.Label("setText",noLinkSecTitle);
						scanBtn.trigger("BTN_CLICK");
					}catch(e){}
				});
				//监听恢复出厂设置成功 
				api.addEventListener({"name":"conmmonRefresh"},function(e){
					try{
						secText.Label("setText",noLinkSecTitle);
						scanBtn.trigger("BTN_CLICK");
						NotePenDataModel.getData();
					}catch(e){}
				});
			}catch(e){}
			
			//解绑笔成功
			$(window).bind("UNBIND_NOTE_PEN_DATA_SUCCESS",function(e,data){
				try{
					scanBtn.trigger("BTN_CLICK");
					NotePenDataModel.getData();
				}catch(e){
					alert(e);
				}
				api.toast({
					msg: '解绑成功',
					duration: 1000,
					location: 'middle'
				});
			});
			//解绑笔失败
			$(window).bind("UNBIND_NOTE_PEN_DATA_ERROR",function(){
				 api.toast({
					msg: '网络请求失败',
					duration: 1000,
					location: 'middle'
				});
			});
			
			//获取党建笔成功
			$(window).bind("GET_NOTE_PEN_DATA_SUCCESS",function(e,data){
				var u = navigator.userAgent;
				var penData = [];
				bindPenData = penData;
				linked = NotePenDataModel.getLinked(); //已经连接
				if(linked == 1){
					var linkedPenData = NotePenDataModel.getLocationLinkedPen();
					Controller.addLoseLinkEvent();
				}
				var pos = 0;
				if(typeof(data.data) == "undefined"){
					data.data = [];
				}
				for(var i=0;i<data.data.length;i++){
					var one = {};
					one.name = data.data[i].penName;
					one.mac = data.data[i].penMacAddr;
					one.snAddr = data.data[i].penSnAddr;
					one.uuid = data.data[i].id;
					one.penType = data.data[i].penType;
					// if(u.indexOf('Android') > -1 || u.indexOf('Linux') > -1){
					// 	if(typeof(linkedPenData) != "undefined" && (linkedPenData.mac == one.mac)){
					// 		one.labelText = "断开连接";
					// 		one.style = "red";
					// 		pos = i;
					// 	}
					// }else{
					// 	if(typeof(linkedPenData) != "undefined"){
					// 		if(linkedPenData.mac == one.snAddr || linkedPenData.mac == one.mac){
					// 			one.labelText = "断开连接";
					// 			one.style = "red";
					// 			pos = i;
					// 		}
					// 	}
					// }
					if(typeof(linkedPenData) != "undefined"){
						if(linkedPenData.mac == one.snAddr || linkedPenData.mac == one.mac){
							one.labelText = "断开连接";
							one.style = "red";
							pos = i;
						}
					}
					penData.push(one);
				}
				if(pos != 0){
				    penData.unshift(JSON.parse(JSON.stringify(penData[pos])));
				    penData.splice(pos+1,1);
				}
				that.checkDataOnline();
				if(first){
					first = false;
					Controller.findLocationPen();
				}else{
					$(".pen-cell").each(function(){
						$(this).PenCell("setBtnEnable");
					});
				}
				
			});
			//笔建立连接 
			try{
				api.addEventListener({"name":"LinkYsPenSuccess"},function(e){
					//可能收到多个事件-只触发一个飘窗-android不稳定
					detailBtn.css({"opacity":1}).show();
					api.toast({
						msg: '蓝牙连接成功',
						duration: 1000,
						location: 'middle'
					});
					var sen = NotePenDataModel.getLocationLinkedPenWithNoEvent();
					Shell.sendEvent("linkSecc",{"name":linkingPenData.name});
					$("[data-mac='"+e.value.mac+"']").PenCell("setToLinked");
					if(e.value.mac == linkingPenData.mac || e.value.mac == linkingPenData.snAddr){ //连的笔是点击的
						//判断当前连接的笔是否是设置自动连接
						if(linkingPenData.mac != sen.mac && linkingPenData.snAddr != sen.mac){
							NotePenDataModel.setLocationLinkedPen({"mac":e.value.mac,"autoLink":0,"name":linkingPenData.name,"penName":typeof(e.value.penName) != "undefined"?e.value.penName:"","penType":typeof(e.value.penType) != "undefined" ? e.value.penType : "4"});
						}
						mainText.Label("setText",linkingPenData.name);
						secText.Label("setText",e.value.mac);
					}
					scanBtn.BaseBtn("setEnable");
					detailBtn.BaseBtn("setEnable");
					$(".pen-cell").each(function(){
						$(this).PenCell("setBtnEnable");
					});
					linkingPenData = null;
					linked = 1;
					if($("[data-mac='"+e.value.mac+"']").hasClass("nobindPen")){
						secText.Label("setText",e.value.mac);
						first = true;
						scrollPanel.remove();
						scrollPanel = null;
						scanBtn.BaseBtn("setDisable");
						scanBtn.BaseBtn("changeText","检索中");
						NotePenDataModel.getData();
					}
				});
			}catch(e){}
			
			if(typeof(api) == "undefined"){
				TokenDataModel.ACCOUNT_CODE = "3845536128749059108";
			}else{
				TokenDataModel.ACCOUNT_CODE = localStorage.getItem("accountCode");
			}
		},
		
		findLocationPen:function(){
			var u = navigator.userAgent;
			//调用蓝牙发现一下笔
		    try{
				foundPenData = [];
				api.addEventListener({"name":"foundYsPenList"},function(e){
					try{
						api.removeEventListener({"name":"foundYsPenList"});
						var cacheData = e.value.data;
						cacheData = JSON.parse(cacheData);
						foundPenData = [];
						var macArr = [];
						if(bindPenData.length > 0){
							for(var i=0;i<bindPenData.length;i++){
								if(u.indexOf('Android') > -1 || u.indexOf('Linux') > -1){
									macArr.push(bindPenData[i].mac);
								}else{
									if(parseInt(bindPenData[i].penType) == 4){
										macArr.push(bindPenData[i].snAddr);
									}else{
										macArr.push(bindPenData[i].mac);
									}
								}
							}
						}
							
					
						for(var i=0;i<cacheData.length;i++){
							var one = {};
							one.name = "蓝牙笔";
							one.mac = cacheData[i].macAddress;
							one.uuid = "no";
							one.penType = cacheData[i].penType;
							//如果附近的笔出现在已经连过的笔中，则过滤
							if(macArr.indexOf(one.mac)  == -1){
								foundPenData.push(one);
							}
						}
					}catch(e){
						//alert("2"+e);
					}
					Controller.checkDataLocation();
				});
				//向原生壳询问附近设备
				Shell.sendEvent("startScanYsPen");
			}catch(e){
				Controller.checkDataLocation();
			}
			setTimeout(function(){
				Shell.sendEvent("getScanYsPenResult");
			},2000);
		},
		
		hideOpenedBindPen:function(){
			$(".openBindedPen").remove();
			myScroll.refresh();
		},
		showAllBindPen:function(){
			linked = NotePenDataModel.getLinked(); //已经连接
			if(linked == 1){
				var linkedPenData = NotePenDataModel.getLocationLinkedPen();
			}		
			
			for(var i=0;i<bindPenData.length;i++){
				if(i >= 3){ 
					bindPenData[i].needDelete = true;
					if(linkedPenData && linkedPenData.mac == bindPenData[i].mac){
						bindPenData[i].style = "red";
					}
					var li = $("<li></li>").PenCell(bindPenData[i]);
					if(linkedPenData && linkedPenData.mac == bindPenData[i].mac){
						li.PenCell("setToLinked");
					}
					li.addClass("bindedPen");
					li.addClass("openBindedPen");
					if(gotoLink){
						li.PenCell("setBtnDisable");
					}
					li.css("opacity",0);
					li.bind("DELETE_BTN_CLICK",Controller.onDeleteBtnClick);
					li.bind("ENTER_DELETE_MODE",function(){
						$(this).siblings().each(function(){
							if($(this).hasClass('pen-cell')){
								$(this).PenCell("cancelDeleteMode");
							}
						});
					});
					li.bind("CELL_BTN_CLICK",Controller.cellBtnClick);
					$("#wrapper").find(".mid").before(li);
					li.animate({"opacity":1},500);
				}
			}
			myScroll.refresh();
		},
		checkDataOnline:function(){
			var that = this;
			if(scrollPanel){
				scrollPanel.remove();
			}
			if(myScroll){
				myScroll.destroy();
			}
			//foundPenData = [];
			if(bindPenData.length == 0){ //没有发现的笔和绑定的笔
			    scrollPanel = $("<div id='wrapper'></div>");
			    scrollPanel.css("overflow","hidden");
				scrollPanel.css({"width":"100%","height":$(window).height()-penTitlePanel.offset().top-penTitlePanel.height()+"px","background":"#F8F8F8"});
				$("body").append(scrollPanel);
				ul = $("<ul></ul>");
				scrollPanel.append(ul);
			}else{
				penTitlePanel.css("border-bottom","0px");
				try{
					mainText.Label("setText","蓝牙笔");
					secText.animate({"opacity":1},500,function(){});
					scrollPanel = $("<div id='wrapper'></div>");
					scrollPanel.css("overflow","hidden");
					scrollPanel.css({"width":"100%","height":$(window).height()-penTitlePanel.offset().top-penTitlePanel.height()+"px","background":"#F8F8F8"});
					$("body").append(scrollPanel);
					ul = $("<ul></ul>");
					scrollPanel.append(ul);
					var hasTitleList =  $("<div class='hasTitleList'></div>").TitleList({"title":"已有设备","fontSize":"14px","color":"#000000","fontWeight":"800","height":"40px","style":1});
					ul.append(hasTitleList);
					for(var i=0;i<bindPenData.length;i++){
						if(i < 3){ //不超过3个显示出来
							bindPenData[i].needDelete = true;
							var li = $("<li></li>").PenCell(bindPenData[i]);
							li.PenCell("setBtnDisable");
							li.addClass("bindedPen");
							li.bind("DELETE_BTN_CLICK",Controller.onDeleteBtnClick);
							li.bind("ENTER_DELETE_MODE",function(){
								$(this).siblings().each(function(){
									if($(this).hasClass('pen-cell')){
										$(this).PenCell("cancelDeleteMode");
									}
								});
							});
							li.bind("CELL_BTN_CLICK",Controller.cellBtnClick);
							ul.append(li);
						}
					}
					if(bindPenData.length > 3){
						var mid = $("<li></li>").Panel({"width":"100%","height":"30px"});
						mid.addClass("mid");
						mid.addClass("open");
						var img = $("<div></div>").Img({"src":"../djcommon/img/note/more.png","width":"16px","height":"18px"});
						img.css("margin","0px auto");
						img.find("img").css("position","relative");
						img.bind("click",function(){
							if(scanBtn.BaseBtn("getStatus") == false){
								return;
							}
							if($($(this).parents("li")[0]).hasClass("open")){ //展开被点击
								$(this).addClass("d180");
								$($(this).parents("li")[0]).removeClass("open");
								that.showAllBindPen();
							}else{
								$(this).removeClass("d180");
								$($(this).parents("li")[0]).addClass("open");
								that.hideOpenedBindPen();
							}
						});
						mid.Panel("addElement",img);
						ul.append(mid);
						function move(){
							mid.animate({"padding-top":"10px"},800,function(){
						        mid.animate({"padding-top":"0px"},0,function(){
								    move();
								});
							});
						}
						move();
					}
					ul.css("min-height",parseInt(scrollPanel.css("height").replace("px",""))+1+"px");
					myScroll = new IScroll("#wrapper",{
						bounceTime:300,
						probeType:3,
					});
					myScroll.on("scrollStart",function(){
						//Shell.sendEvent("LockSwitchActivity");
					});
					myScroll.on("scrollEnd",function(){
						//Shell.sendEvent("unLockSwitchActivity");
					});
					myScroll.on('scroll',function(){
						$(".pen-cell").each(function(){
						    $(this).PenCell("cancelDeleteMode");
						})
					});
				}catch(e){
				}
				
			}
			linked = NotePenDataModel.getLinked(); //已经连接
			if(linked == 1){
				detailBtn.show();
				detailBtn.animate({"opacity":1},500,function(){});
				detailBtn.BaseBtn("setDisable");
				var linkedPenData = NotePenDataModel.getLocationLinkedPen();
				secText.Label("setText",linkedPenData.mac);
				mainText.Label("setText",linkedPenData.name);

				scanBtn.BaseBtn("setEnable");
				scanBtn.BaseBtn("changeText","检索设备");
			}
		},
		removeLoseLinkEvent:function(){
			api.removeEventListener({"name":"loseLinkYsPen"});
		},
		addLoseLinkEvent:function(){
			//笔断开连接
			try{
				api.addEventListener({"name":"loseLinkYsPen"},function(e){
					api.removeEventListener({"name":"loseLinkYsPen"});
					scanBtn.BaseBtn("setEnable");
					if(typeof(e.value) == "undefined" || e.value == "" || e.value == null){
						linked = 0;
						api.toast({
							msg: "连接已取消",
							duration: 1000,
							location: 'middle'
						});
						var u = navigator.userAgent;
						if(u.indexOf('Android') > -1 || u.indexOf('Linux') > -1){
							$("[data-mac='"+linkingPenData.mac+"']").PenCell("setToDefault");
						}else{
							if(parseInt(linkingPenData.penType) == 4){
								$("[data-mac='"+linkingPenData.snAddr+"']").PenCell("setToDefault");
							}else{
								$("[data-mac='"+linkingPenData.mac+"']").PenCell("setToDefault");
							}
						}
						$(".pen-cell").each(function(){
							$(this).PenCell("setBtnEnable");
						});
						mainText.Label("setText","蓝牙笔");
						secText.Label("setText",noLinkSecTitle);
						return;
					}
					linked = 0;
					if($("[data-mac='"+e.value.mac+"']").PenCell("getStyleStatus") == "red"){ //已连接的笔断开连接
						$("[data-mac='"+e.value.mac+"']").PenCell("setToDefault");
						$(".pen-cell").each(function(){
							$(this).PenCell("setBtnEnable");
						});
						detailBtn.css({"opacity":1}).hide();
						mainText.Label("setText","蓝牙笔");
						secText.Label("setText",noLinkSecTitle);
						api.toast({
							msg: "蓝牙连接已断开",
							duration: 1000,
							location: 'middle'
						});
					}else{ //尝试连接的笔连接失败
						api.toast({
							msg: "连接超时",
							duration: 1000,
							location: 'middle'
						});
						if(linkingPenData){
							var u = navigator.userAgent;
							if(u.indexOf('Android') > -1 || u.indexOf('Linux') > -1){
								$("[data-mac='"+linkingPenData.mac+"']").PenCell("setToDefault");
							}else{
								if(parseInt(linkingPenData.penType) == 4){
									$("[data-mac='"+linkingPenData.snAddr+"']").PenCell("setToDefault");
								}else{
									$("[data-mac='"+linkingPenData.mac+"']").PenCell("setToDefault");
								}
							}
						}
						$(".pen-cell").each(function(){
							$(this).PenCell("setBtnEnable");
						});
						mainText.Label("setText","蓝牙笔");
						secText.Label("setText",noLinkSecTitle);
					}
				});
			}catch(e){}
		},
		checkDataLocation:function(){
			var that = this;
			if(foundPenData.length == 0){ //没有发现的笔和绑定的笔
				
			}else{
				penTitlePanel.css("border-bottom","0px");
				try{
					var newTitleList =  $("<div class='newTitle'></div>").TitleList({"title":"新的设备","fontSize":"14px","color":"#000000","fontWeight":"800","height":"40px","style":1});
					newTitleList.TitleList("setMarginTop","5px");
					ul.append(newTitleList);
					for(var i=0;i<foundPenData.length;i++){
						foundPenData[i].labelText = "连接";
						var li = $("<li class='newCell'></li>").PenCell(foundPenData[i]);
						li.PenCell("setBtnDisable");
						li.addClass("nobindPen");
						li.bind("CELL_BTN_CLICK",function(e,arg){
							$(".pen-cell").each(function(){
								$(this).PenCell("setBtnDisable");
							});
							if(linked == 1){
								try{
									api.addEventListener({"name":"AlertHasBeedClick"},function(e){
										api.removeEventListener({"name":"AlertHasBeedClick"});
										$(".pen-cell").each(function(){
											$(this).PenCell("setBtnEnable");
										});
										detailBtn.css({"opacity":1});
										detailBtn.BaseBtn("setEnable");
									});
									Shell.sendEvent("ShowMeTheAlert",{"title":"您已连接蓝牙笔，请断开后再连接","btn":["确认"]});
								}catch(e){}
							}else{
								scanBtn.BaseBtn("setDisable");
								linkingPenData = {"mac":$(this).attr("data-mac"),"name":"蓝牙笔"};
								var currMac = $(this).attr("data-mac");
								api.addEventListener({"name":"LinkYsPenGetLocalBluetoothAndPositionStatus"},function(e){
					   				api.removeEventListener({"name":"LinkYsPenGetLocalBluetoothAndPositionStatus"});
									if(e.value.status == 0){ //授权不正确,提示用户授权
										try{
											api.addEventListener({"name":"AlertHasBeedClick"},function(e){
												api.removeEventListener({"name":"AlertHasBeedClick"});
												$(".pen-cell").each(function(){
													$(this).PenCell("setBtnEnable");
													$(this).PenCell("setBtnText","连接");
												});
											});
											Shell.sendEvent("ShowMeTheAlert",{"title":"请先开启蓝牙及位置服务功能","btn":["确认"]});
										}catch(e){}
									}else{
										Controller.addLoseLinkEvent();
							  			Shell.sendEvent("startLinkYsPen",{"mac":currMac,"linked":"0","penType":typeof(arg.penType) != "undefined" ? arg.penType : 4});
									}
								});
								//向原生壳询问定位和蓝牙权限
								Shell.sendEvent("getLinkYsPenGetLocalBluetoothAndPositionStatus");
							}
						});
						ul.append(li);
					}
					ul.css("min-height",parseInt(scrollPanel.css("height").replace("px",""))+1+"px");
					myScroll.refresh();
				}catch(e){
					//alert("1"+e);
				}
				
			}
			scanBtn.BaseBtn("changeText","检索设备");
			$(".pen-cell").each(function(){
			    $(this).PenCell("setBtnEnable");
			});
			scanBtn.BaseBtn("setEnable");
			linked = NotePenDataModel.getLinked(); //已经连接
			if(linked == 1){
				detailBtn.show();
				detailBtn.animate({"opacity":1},500,function(){});
				detailBtn.BaseBtn("setEnable");
				var linkedPenData = NotePenDataModel.getLocationLinkedPen();
				secText.Label("setText",linkedPenData.mac);
				mainText.Label("setText",linkedPenData.name);
			}
		}
    }
    
    return Controller;
});
